#pragma once

#include "X\XCommThread.h"
#include "FactoryLib\EqpAssy.h"
#include "DicsData.h"

#define MAX_DATA_NO 15

//////////////////////////////////////////
// 231212 halesu 
// PJT : 23MT025
// developed for Scan Device of other company
// 
class CCommModbusRTU : public XCommThread  
{
public:
	CCommModbusRTU();
	virtual ~CCommModbusRTU();

	enum ControlCharacters {
		ccADDR = 0x01,		// Slave Address
		ccFUNC = 0x03,		// Function Code
	};

	enum _TERMINATE_CODE{
		ccOK = 0x11,
		ccNG = 0x0F,
	};

	int		m_nTerminateCode;
	CString m_sCurData;
	BOOL	m_bRecvCommand;
	CString m_sSendData;

	CEqpAssy*			m_pEqpAssy;		// Get Sensor Status
	CDicsData*			m_pDicsData;	// Get Glass Data

	void SetEqpAssy( CEqpAssy* pEqpAssy )						{ m_pEqpAssy = pEqpAssy; }
	void SetData( CDicsData* pData)								{ m_pDicsData	= pData; }

protected:
	void DataReceived();
	void Reset();
	void SendCommand();
	void SetLog(CString sSeqName, int nPortNo, int nSlotNo, CString sMessage);
	void UpdateData();
	int CalDataBytes( int nStartAddress, int nQuantity);
	int CalDataAddress( int nStartAddress);

	void InvertUint8(unsigned char *DesBuf, unsigned char *SrcBuf);
	void InvertUint16(unsigned short *DesBuf, unsigned short *SrcBuf);
	unsigned short CRC16_MODBUS(unsigned char *puchMsg, unsigned int usDataLen);
};