#ifndef _DEFINE_H
#define _DEFINE_H

#define _TITLE  "DICS_AUO_L6A_TFT_ITO_CLN_240614 " __DATE__

#define _DICS_ROOT	"D:\\DICS\\"

#define _MY_DEBUG					//SIMULATION USE
#define _LOADER_DEBUG				//SIMULATION USE
#define _SIMULATE_MELSEC			//SIMULATION USE

#define _MOTOR_LOAD_FACTOR		// DICS folder -> AiControl -> Mortor Load Factor Ver Select Change copy

/********************************************* AUO BUF TANK ADD *******************************************/
#define _BUFTANK_USE		//200413 hskwak BufTank Add
/**********************************************************************************************************/

//#define _CIM_SKIP					//CIM NO USE
//#define _SKIP_SCAN				//SCAN NO USE
//#define __LOG__
//#define _TYPE1					//	SPT(#200,300,400)
//#define _TYPE2					//	CVD(#600)
//#define _TYPE3					//	CVD(#400)
//#define _TYPE4					//	CVD(#200,300)
//#define _TYPE5					//	CVD(#500,700)
//#define _TYPE6					//  CVD(#800)
#define _TYPE7						//	SPT(#J00, PRE_ITO)

//#define _MY_INTERLOCK_UL_CYLINER			// OutConv Interlock Skip


// Motor HomeCheck Method
#define _MOT_REPEAT
#define _MOT_HOMEOUT

/********* Check EQP Status *********/
//#define _MJ1_MJ4_COMBINE	// SPT(#200)	121012 halesu
//#define _DI_MODE		//	CVD(#200,300)	130812 halesu
/************************************/

///////////////////////////////////////////////////////////////////////////////////////////////
#if defined (_TYPE1)	// SPT(#200,300,400) 
#define _LTYPE
#define _NO_RB
#define _SPT_TYPE

#elif defined (_TYPE2)	//	CVD(#600)
#define _NO_RB
#define _NO_UL_HAND
#define _NO_EUV
#define _CV_TYPE

#elif defined (_TYPE3)	//	CVD(#400)
#define _LTYPE
#define _NO_EUV

#elif defined (_TYPE4)	//	CVD(#200,300)
#define _NO_EUV

#elif defined (_TYPE5)	//	CVD(#500,700)
#define _LTYPE
#define _NO_RB
#define _NO_UL_HAND
#define _NO_EUV
#define _CV_TYPE

#elif defined (_TYPE6)	// CVD(#800)
#define _NO_UL_HAND
#define _NO_EUV
#define _CV_TYPE

#elif defined (_TYPE7)	// SPT(#J00)
#define _NO_RB
#define _NO_UL_HAND
#define _NO_AP
#define _NO_HPMJ
#define _SPT_TYPE
#endif

#define _NO_EUV

#define ABS_VAL(A)				(((A) > 0) ? (A) : -(A))

#define TIMER_ON(A,B)			m_pTimer->TimerTurnOn(A,B)
#define TIMER(A)				m_pTimer->Timer(A)

//////////////////////////////////////////////////////////////////////////
/////////////////////// MELSECNET10 //////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
#ifndef _CIM_SKIP
#define UMelInput(no)					( m_pMelsec->ReceiveBit( m_pMelsec->m_NetworkInfo.nUpNetworkNo, m_pMelsec->m_NetworkInfo.nUpStationNo, (no) ) )
#define UMelOutput(no, val)				( m_pMelsec->SendBit( m_pMelsec->m_NetworkInfo.nUpNetworkNo, m_pMelsec->m_NetworkInfo.nUpStationNo, (no), (val) ) )
#define LMelInput(no)					( m_pMelsec->ReceiveBit( m_pMelsec->m_NetworkInfo.nDnNetworkNo, m_pMelsec->m_NetworkInfo.nDnStationNo, (no) ) )
#define LMelOutput(no, val)				( m_pMelsec->SendBit( m_pMelsec->m_NetworkInfo.nDnNetworkNo, m_pMelsec->m_NetworkInfo.nDnStationNo, (no), (val) ) )
#define MelInput(no)					( m_pMelsec->ReceiveBit( m_pMelsec->m_NetworkInfo.nNetworkNo, m_pMelsec->m_NetworkInfo.nStationNo, (no) ) )
#define MelOutput(no, val)				( m_pMelsec->SendBit( m_pMelsec->m_NetworkInfo.nNetworkNo, m_pMelsec->m_NetworkInfo.nStationNo, (no), (val) ) )

//#define BMelRead(no, i)			    ( ( ( m_pMelsec->ReceiveWord( m_pMelsec->m_NetworkInfo.nUpNetworkNo, m_pMelsec->m_NetworkInfo.nUpStationNo, (no) ) >> i ) & 0x01 ) ? 1 : 0 )
#define BMelRead(no, i)					( ( m_pMelsec->ReceiveWord( m_pMelsec->m_NetworkInfo.nUpNetworkNo, m_pMelsec->m_NetworkInfo.nUpStationNo, (no) ) & (0x01<<(i)) ) ? 1 : 0 )
#define BMelWrite(no, val, i)           ( m_pMelsec->SendWord( m_pMelsec->m_NetworkInfo.nUpNetworkNo, m_pMelsec->m_NetworkInfo.nUpStationNo, (no), ((val & 0x01) << i ) ) ) 

#define UMelRead(no)					( m_pMelsec->ReceiveWord( m_pMelsec->m_NetworkInfo.nUpNetworkNo, m_pMelsec->m_NetworkInfo.nUpStationNo, (no) ) )
#define UMelWrite(no, val)				( m_pMelsec->SendWord( m_pMelsec->m_NetworkInfo.nUpNetworkNo, m_pMelsec->m_NetworkInfo.nUpStationNo, (no), (val) ) )
#define LMelRead(no)					( m_pMelsec->ReceiveWord( m_pMelsec->m_NetworkInfo.nDnNetworkNo, m_pMelsec->m_NetworkInfo.nDnStationNo, (no) ) )
#define LMelWrite(no, val)				( m_pMelsec->SendWord( m_pMelsec->m_NetworkInfo.nDnNetworkNo, m_pMelsec->m_NetworkInfo.nDnStationNo, (no), (val) ) )
#define MelRead(no)						( m_pMelsec->ReceiveWord( m_pMelsec->m_NetworkInfo.nNetworkNo, m_pMelsec->m_NetworkInfo.nStationNo, (no) ) )
#define MelWrite(no, val)				( m_pMelsec->SendWord( m_pMelsec->m_NetworkInfo.nNetworkNo, m_pMelsec->m_NetworkInfo.nStationNo, (no), (val) ) ) 

#define UMelWriteString(no, val, len) 	( m_pMelsec->WriteString(m_pMelsec->m_NetworkInfo.nUpNetworkNo, m_pMelsec->m_NetworkInfo.nUpStationNo, (no), (val), (len) ) )
#define UMelReadString(no, val, len)	( m_pMelsec->ReadString(m_pMelsec->m_NetworkInfo.nUpNetworkNo, m_pMelsec->m_NetworkInfo.nUpStationNo, (no), (val), (len) ) )
#define LMelWriteString(no, val, len) 	( m_pMelsec->WriteString(m_pMelsec->m_NetworkInfo.nDnNetworkNo, m_pMelsec->m_NetworkInfo.nDnStationNo, (no), (val), (len) ) )
#define LMelReadString(no, val, len)	( m_pMelsec->ReadString(m_pMelsec->m_NetworkInfo.nDnNetworkNo, m_pMelsec->m_NetworkInfo.nDnStationNo, (no), (val), (len) ) )
#define MelWriteString(no, val, len) 	( m_pMelsec->WriteString(m_pMelsec->m_NetworkInfo.nNetworkNo, m_pMelsec->m_NetworkInfo.nStationNo, (no), (val), (len) ) )
#define MelReadString(no, val, len)		( m_pMelsec->ReadString(m_pMelsec->m_NetworkInfo.nNetworkNo, m_pMelsec->m_NetworkInfo.nStationNo, (no), (val), (len) ) )

#else
#define UMelInput(no)					( m_pFileMap->ReceiveBit( no ) )
#define UMelOutput(no, val)				( m_pFileMap->SendBit( (no), (val) ) )
#define LMelInput(no)					( m_pFileMap->ReceiveBit( no ) )
#define LMelOutput(no, val)				( m_pFileMap->SendBit( (no), (val) ) )
#define MelInput(no)					( m_pFileMap->ReceiveBit( no ) )
#define MelOutput(no, val)				( m_pFileMap->SendBit( (no), (val) ) )

#define BMelRead(no, A)					(( m_pFileMap->ReceiveWord(no) & (0x01<<(A)) ) ? 1 : 0 )
#define BMelWrite(no, val, A)           ( m_pFileMap->SendWord( (no), ((val & 0x01) << A ) ) ) 

#define UMelRead(no)					( m_pFileMap->ReceiveWord( no ) )
#define UMelWrite(no, val)				( m_pFileMap->SendWord( (no), (val) ) )
#define LMelRead(no)					( m_pFileMap->ReceiveWord( no ) )
#define LMelWrite(no, val)				( m_pFileMap->SendWord( (no), (val) ) )
#define MelRead(no)						( m_pFileMap->ReceiveWord( no ) )
#define MelWrite(no, val)				( m_pFileMap->SendWord( (no), (val) ) ) 

#define UMelWriteString(no, val, len) 	( m_pFileMap->WriteString( (no), (val), (len) ) )
#define UMelReadString(no, val, len)	( m_pFileMap->ReadString( (no), (val), (len) ) )
#define LMelWriteString(no, val, len) 	( m_pFileMap->WriteString( (no), (val), (len) ) )
#define LMelReadString(no, val, len)	( m_pFileMap->ReadString( (no), (val), (len) ) )
#define MelWriteString(no, val, len) 	( m_pFileMap->WriteString( (no), (val), (len) ) )
#define MelReadString(no, val, len)		( m_pFileMap->ReadString( (no), (val), (len) ) )
#endif
//////////////////////////////////////////////////////////////////////////

#include "DefineConstant.h"
#include "DefineAuoL8BMelsecMap.h"
#include "DefineTypedef.h"
//#ifdef _NO_RB


#ifdef _MOTOR_LOAD_FACTOR
#include "DefineAlarmMotorLoadFactor.h"
#else
#include "DefineAlarm_MJ.h"
#endif


// #else
// #include "DefineAlarm.h"
// #endif
#ifdef _CIM_SKIP
#include "FileMap.h"
#endif

#endif	// _DEFINE_H