// DicsData.h: interface for the CDicsDataBase class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DICSDATABASE_H__B76AF5E0_F1B7_423C_B146_BC468046625B__INCLUDED_)
#define AFX_DICSDATABASE_H__B76AF5E0_F1B7_423C_B146_BC468046625B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "PortInfo.h"
#include "..\FactoryLib\IniData.h"	// Added by ClassView

// General information.
class CGenInfo : public CObject
{
public:
	BOOL	bAuto;				// 1 : Auto, 0 : Manual (Navigation Button)
	BOOL	bCleanOut;			// 1 : Clean out, 0 : Normal;
	BOOL	bCycleStop;			// Cycle Stop (Command Button)
	BOOL	bPause;				// Pause (Command Button)
	BOOL    bUlTimeOut;
	BOOL	bUlNotReady;
	BOOL	bAkInterlock;
	BOOL	bIdleRunning;		// Idle Running (Yes / No)
	BOOL	bEqpInitReq;
	BOOL	bEqpInitComp;
	BOOL	bEmo;
	BOOL	bCoverOpen;
	BOOL	bDoorOpen;
	BOOL	bLdDoorOpen;
	BOOL	bUlDoorOpen;
	BOOL	bSaftyDoorOpen;
	BOOL	bLeakSensor;
	BOOL	bAreaSensor;
	BOOL	bIonizerAlarm;
	BOOL	bFfuAlarm;
	BOOL	bSbjStop;
	BOOL	bEnableCommLog;		// Log Option in DicsView List box
	BOOL	bEnableEqpLog;		// Log Option in DicsView List box
	BOOL	bRecipeBodyChanged;
	BOOL	bLdUnitGlassStart;
	BOOL	bDirectRecv;	
	UINT	nTotalGlassNo;		// Historical glass number
	int		nGlassNo;			// Equipment Glass Number
	int		nJobMode;			// 1 : Pass Mode, 0 ; Normal (Command Button)
	int		nRealTactTime;	
	int		nMaxEqpGlassNo;
	int		nRecipeId; //JUN_MELSEC
	CString	sRecipeId;			// Using Recipe No, pDoc->m_sRecipeNo : Use for DB
	CString sOpId;
	BOOL	bDataRecvCheck;
	int		nDataCheckCount;
	BOOL	bMjCdaReady[2];	// 100908 halesu
	BOOL	bIFLoaderEmoInterlock;	// SanghoCho 2015.05.04
	BOOL	bScanDeviceAlarm;	// 240606 halesu
	BOOL	bScanDeviceAlarmCheck;	// 240606 halesu
public:
	void ClearInfo();
};

// Apply to whole equipment.
class CEqpInfo : public CObject
{
public:
	//------- Equipment Status
	int		nEqpState[MAX_EQP_STATE_NO];	// Run, Stop, Idle, Down, Pause, Alarm, Warning, Warning To Much
	int		nLdState[MAX_EQP_STATE_NO];	// Run, Stop, Idle, Down, Pause, Alarm, Warning, Warning To Much
	//----------------------------------	
	int		nUnitNo;
	char	cEqpState;			// Main Equipment status
	char	cLdState;			// Loader status
	char	cCtlMode;			// 'D' : Offline, 'B' : Online Monitor, 'A' : Online Control
	char	cCIMPCMode;			// 'D' : Offline, 'A' : Online control
	char	cTrsMode;			// '4' : AGV, '5' : MGV
	CString sHostTime;			// The value of S2F18
	char    cAlarmState;		// 0 : None, L : Light alarm, S : Heavy alarm
	char	cOpMode;			// 1 : Normal Mode, 3 : Recovery Mode, 6 : Particle Check
	char	cModuleID;			// 'PDC120' : SAHDC, 'HFC120' : HF SAHDC

	float	fSensorOnScore[MAX_GLS_EXIST_SENSOR_NO];
	float	fSensorOffScore[MAX_GLS_EXIST_SENSOR_NO];
public:
	void ClearInfo();
};

// Pump
class CIfPump : public CObject
{
public:
	BOOL	bDiStart;					// DI Run
	BOOL	bCleaningStart;				// Cleaning Run
	BOOL	bChemicalStart[MAX_CHEMICAL_TYPE_NO];
public:
	void ClearInfo();
};

// EUV
class CIfEuv : public CObject
{
public:
	BOOL    bLampAlarm;
	BOOL    bLampPause;
	BOOL	bLampOnComp;
	BOOL	bLampOnFail;
	BOOL    bLampIntensityCheckReq[MAX_LAMP_INTENSITY_NO];
	BOOL    bLampIntensityCheckComp[MAX_LAMP_INTENSITY_NO];
	BOOL    bLampIntensityCheckFail[MAX_LAMP_INTENSITY_NO];
	double	nLampIntensity[MAX_LAMP_INTENSITY_NO];
	UINT	nLampOnTime[MAX_LAMP_NO];
	BOOL	bEuvUtilAlarm;	//eun 070322
	float	fLampIntensity[MAX_LAMP_INTENSITY_NO];
public:
	void ClearInfo();
};

// BROKEN SCAN 
class CIfScan : public CObject
{
public:
	BOOL    bGlassBroken[MAX_SCAN_NO];
	CString sStatus[MAX_SCAN_NO];
public:
	void ClearInfo();
};

// CCD Sensor 120111 halesu 
class CIfCcd : public CObject
{
public:
	BOOL    bGlassBroken;
	CString sStatus;
public:
	void ClearInfo();
};

class CSeqFlag : public CObject
{
public:
	BOOL	bInitServo;
	BOOL    bSemiAutoMove;
	BOOL    bServoMove;
	BOOL	bTimeOver;
	BOOL	bStopCount1; // For the calculation of tact time.
	BOOL	bStopCount2; // For the calculation of tact time.
	BOOL	bCvStop[MAX_UNIT_NO];
	BOOL	bSeqStopState[MAX_STOP_COUNT_NO][MAX_UNIT_NO];
	int		nRollerState[MAX_STOP_COUNT_NO][MAX_UNIT_NO];
	int		nRollerStateAll[MAX_STOP_COUNT_NO][MAX_UNIT_NO];
	BOOL	bGlassOutComp1;	// Unloading C/V Glass Ǿ Ȯ ϴ Flag
	BOOL	bGlassOutComp2;	// TR Unit Glass  Ϸ Ǿ Ȯ ϴ Flag
	BOOL	bGlassGetComp;
	BOOL	bUlUnitRecvReady;
	BOOL    bUlHandAlarm;
	BOOL    bPreRecvReady;
	BOOL	bUnloadProcess;	// 100412 halesu
public:
	void ClearInfo();
};

// interface flag
class CIfUnit : public CObject
{
public:
	BOOL bInReady;
	BOOL bInComp;
	BOOL bOutReady;
	BOOL bOutComp;
	BOOL bWaitPos;
	BOOL bInError;
	BOOL bOutError;
	BOOL bSeqStop;
	BOOL bInSick;		// In Sensor ҷ
	BOOL bOutSick;		// Out Sensor ҷ
	BOOL bSubInSick;		// In Sensor ҷ
	BOOL bSubOutSick;		// Out Sensor ҷ
	BOOL bInLogicCheckIgnore;
	BOOL bOutLogicCheckIgnore;	
	
//	BOOL bAlarm;    
	BOOL bRecoveryReq;
	BOOL bCvBwReq;

	BOOL bRecvReady;	// LD Glass Recv Ready (TrSeq) ---> BUF3 Unit Can Send Glass (CvSeq1) --> CvSeq Stop
	BOOL bSendReady;	// LD Glass Send Ready (TrSeq) ---> BUF3 Unit Can Send Glass (CvSeq) --> CvSeq1 Stop
	BOOL bRecvComp;		// LD Glass Recv Comp (CvSeq1) ---> LD UPDN Send Pos Move Request(TrSeq)
	BOOL bSendComp;		// LD Glass Send Comp (CvSeq)  ---> LD UPDN Recv Pos Move Request(TrSeq)
	BOOL bRecvPosComp;	// LD Recv Position Comfirm (TrSeq) ---> SeqUnitLdUl1, SeqUnitLdUl2 Seq Run(CvSeq1) 
	BOOL bSendPosComp;	// LD Recv Position Comfirm (TrSeq) ---> SeqUnitLd() Run (CvSeq) 

	BOOL bRecvReqCv;	// 20100611 ssm for C/V to C/V type
	BOOL bSendReqCv;	// 20100611 ssm for C/V to C/V type

	BOOL bInSensorSkip;		// SanghoCho 2015.04.30 FOR DUAL SENSOR
	BOOL bSubInSensorSkip;	// SanghoCho 2015.04.30 FOR DUAL SENSOR
	BOOL bOutSensorSkip;	// SanghoCho 2015.04.30 FOR DUAL SENSOR
	BOOL bSubOutSensorSkip;	// SanghoCho 2015.04.30 FOR DUAL SENSOR

public:
	void ClearInfo();
};

class CJobCond : public CObject
{
public:
	int		nTactTime;
	int		nCvSpeed;	// C/V Speed
	int		nInCvSpeed;
	int		nOutCvSpeed;
	BOOL	bJobProcessUse;
	int		nCvSpeedSet[MAX_CV_NO][3]; // normal, Deceleration, Acceleration
	BOOL	bRbUse[MAX_RB_NO];
	double	dRbGap[MAX_RB_GAP_SERVO_NO];
	int		nRbSpeed[MAX_RB_NO];
	BOOL	bRbDir[MAX_RB_NO];
	BOOL	bEuvUse[MAX_LAMP_CONTROL_NO];
	BOOL	bEuvDelayTimeUse;
	int		nEuvStartDistance;
	int		nEuvOnDistance;

	BOOL	bDualSensorSave;	// SanghoCho 2015.04.30 FOR DUAL SENSOR

	enum cvSPEED_TYPE{ speedNORMAL, speedDEC, speedACC, maxSPEED_TYPE };
public:
	void ClearInfo();
};

// CIM Interface.
class CIfCimInfo : public CObject
{
public:
	int			bInlineMode;
	int			nHostStatus;
	int			nUpStreamStatus;
	int			nDnStreamStatus;
	BOOL		bMelsecParaChangeReq;
	BOOL		bTimeCalReq;
	BOOL		bRcpCheckMode;			
	BOOL		bGlassDataCheckMode;
	BOOL		bGlassDataChekResultOk;
	BOOL		bRecipeDeleteReq;
	BOOL		bRecipeDeleteReply;
	int			nDeleteRecipeNo;
	BOOL		bRecipeBodyChangeReq;
	int			nChangeRecipeId;
	BOOL		bGlassDataLostReq;
	BOOL		bGlassDataLostReply;
	int			nLostUnitNo;
	BOOL		bGlassDataRecoveryReq;
	int			nGlassDataRecoveryReply;
	BOOL		bGlassDataReq;
	BOOL		bGlassDataReqReply;
	BOOL		bGlassDataDelete;
	int			nGlassDataDeleteNo;
	int			nRecoveryUnitNo;
	int			nRecoveryListNo;
	BOOL		bTransDataReport[2];
	UINT		nTransDataIndex;
	BOOL		bReceiveStop;
	CString		sOperatorId;
	BOOL        bOperatorIdReport;
	int         nSelectedOpIdNo;
	CString		sDateTime;
	BOOL		bApdReportReq;
	BOOL		bApdReportComp;
	//------ Used for EqpStateSequence
	BOOL		bAlarmSetReq;
	BOOL		bAlarmResetReq;
	BOOL		bAlarmSetComp;
	BOOL		bAlarmResetComp;
	CString		sAlarmText;
	int			nAlarmId;
	int			nAlarmCode;
	char		cAlarmLevel;
	CString		sAlarmTime;
	int			nAlarmUnitNo;
	//------ Used for MainSequence
	BOOL		bKeyInCstIdComp[MAX_PORT_NO];
	//------ CIM Handshaking : View <-> CIM
	char		cCtlMode;						// modeCONTROL, modeMONITOR, modeOFFLINE
	char		cCtlMode1;	
	BOOL		bCtlModeChangeReq;
	BOOL		bCtlModeChangeComp;
	//------ Main Frame <-> CIM Handshaking
	BOOL		bForceRecvCompReq;
	BOOL		bForceRecvInitReq;
	BOOL		bForceSendCompReq;
	BOOL		bForceSendInitReq;
	//------ signal check	20100710 ssm
	BOOL		bSendDataCheck;
public:
	void ClearInfo();
};

// Loader Sequence Interface.
class CIfLoaderInfo : public CObject
{
public:
	//------ Port Mode : CimSequence <-> LoaderSequence
	char	cPortMode[MAX_PORT_NO];
	BOOL	bPortModeChangeReq[MAX_PORT_NO];
	BOOL	bPortModeChangeComp[MAX_PORT_NO];

	//------ TRS Mode : CimSequence <-> LoaderSequence
	char	cTrsMode[MAX_PORT_NO];
	BOOL	bTrsModeChangeReq[MAX_PORT_NO];
	BOOL	bTrsModeChangeComp[MAX_PORT_NO];
	BOOL	bTrsModeChangeLoaderReq[MAX_PORT_NO];

	//------ Port State : CimSequence <-> LoaderSequence
	BOOL	bLdReq[MAX_PORT_NO];
	BOOL	bLdComp[MAX_PORT_NO];
	BOOL	bUlReq[MAX_PORT_NO];
	BOOL	bUlComp[MAX_PORT_NO];

	BOOL	bProcessStartReq[MAX_PORT_NO];
	BOOL	bProcessStartComp[MAX_PORT_NO];

	BOOL	bPortCancelReq[MAX_PORT_NO];
	BOOL	bPortCancelComp[MAX_PORT_NO];

	BOOL	bPortAbortReq[MAX_PORT_NO];
	BOOL	bPortAbortComp[MAX_PORT_NO];

	//------ Glass Exchange Handshaking : MainSequence <-> LoaderSequence
	BOOL	bGlassPutReq;
	BOOL	bGlassGetReq;
	BOOL	bGlassPutComp;
	BOOL	bGlassGetComp;

	//------ Scrap : MainSequence <-> LoaderSequence
	BOOL	bScrapReq;
	int		nScrapPortNo;
	int		nScrapSlotNo;	
public:
	void ClearInfo();
};

class CIfAccumulate : public CObject
{
public:
	int nMaxAccumulateNo;
	int *nAddress;
	CString *sAccumPartName;

};
/////////////////////////////////////////////////////////////////
// Class
class CDicsDataBase : public CObject  
{
public:
	CDicsDataBase();
	virtual ~CDicsDataBase();

	CIniData		m_IniConfiguration;

	CPortInfo		m_PortInfo[MAX_PORT_NO];
	CGlassInfo		m_GlsInfo[2*MAX_IF_NO];
	CGlassInfo		m_GlsInfoRecv;
	CGlassInfo		m_GlsInfoSend;
	CGlassInfo		m_GlsLotEndInfo;
	CGlassInfo		m_GlsMultiInfo;
	CString			m_sFileName;

public:
	enum	_LOGINState			{ idOP, idMAINT, idENGINEER, idADMIN };

	enum _RECV{				// Glass Receiving
		rcvON_IF1,			// Receiving for C/V
		rcvON_IF2,			// Receiving for TR
		rcvREADY,			// EQP Ready[CIM->UPSTREAM]
		rcvUPREADY,			// UP Stream Ready[UPSTREAM->CIM]
		rcvREQ,				// Receive Request
		rcvCOMP_REQ,		// Receive Finished[MAIN->INTERFACE]
		rcvCOMP,			// Receive Finished[INTERFACE->MAIN]
		rcvERROR_REQ,		// Interface Error[MAIN->INTERFACE]
		rcvERROR,			// Interface Error[INTERFACE->MAIN]
		rcvRESET,			// Interface Reset
		rcvCANCEL_REQ,		// Interface Cancel[MAIN->INTERFACE]
		rcvCANCEL,			// Interface Cancel[INTERFACE->MAIN]
		rcvFORCE_COMP,		// Interface Force Complete
		rcvNO_SUBSTRATE,
		rcvMAX_RECV_BIT_NO };

	enum _SEND{				// Glass Sending
		sndON_IF1,			// Sending for C/V
		sndON_IF2,			// Sending for TR
		sndREADY,			// EQP Ready[CIM->DNSTREAM]
		sndDNREADY,			// DN Stream Ready[DNSTREAM->CIM]
		sndREQ,				// Send Request
		sndCOMP_REQ,		// Send Finished[MAIN->INTERFACE]
		sndCOMP,			// Send Finished[INTERFACE->MAIN]
		sndERROR_REQ,		// Interface Error[MAIN->INTERFACE]
		sndERROR,			// Interface Error[INTERFACE->MAIN]
		sndRESET,			// Interface Reset
		sndCANCEL_REQ,		// Interface Cancel[MAIN->INTERFACE]
		sndCANCEL,			// Interface Cancel[INTERFACE->MAIN]
		sndEXCHANGE_REQ,	// Exchange Request
		sndFORCE_COMP,		// Interface Force Complete
		sndMAX_SEND_BIT_NO };

	struct _tagIF_RECV {
		BOOL	bBit[rcvMAX_RECV_BIT_NO];
		CString sData;
	} m_IfRecv;

	struct _tagIF_SEND {
		BOOL	bBit[sndMAX_SEND_BIT_NO];
		CString sData;
	} m_IfSend;

	struct tagLOGIN_INFO{
		int		nCurUserLevel;
		CString sCurUserID;
		BOOL	bIsValid[MAX_ACCOUNT_NO];
		CString sUserID[MAX_ACCOUNT_NO];
		CString sPassword[MAX_ACCOUNT_NO];
		int		nUserLevel[MAX_ACCOUNT_NO];
	} m_LoginInfo;

#ifdef _MY_DEBUG	// for _DEBUG
	BOOL		m_bDebugInSensor[MAX_UNIT_NO];
	BOOL		m_bDebugOutSensor[MAX_UNIT_NO];
	BOOL		m_bDebugInterlockSensor;
#endif

	UINT        uDataId;
	UINT        uRptId;
	UINT        uCeid;

	// Operations
public:
	void ChangePassword(CString sID, CString sPassword);
	BOOL Login( CString sID, CString sPassword );
	BOOL RemUser(CString sID, CString sPassword);
	BOOL AddUser( int nLevel, CString sID, CString sPassword);
	
	void SetGlassData(int i, int nGlassNo);
	void MoveGlassData(int nFrom, int nTo);
	void DeleteGlassData(int i, BOOL bDelete = TRUE);
	void ClearGlassData();
	void GetProfileGlassData(int i);
	void WriteProfileGlassData(int i);
	void ClearPortInfo( int i );

	int	 FindGlassNo();

	void ResetUpStreamIF();
	void ResetDnStreamIF();
};

class CTraceData : public CObject  
{
public:
	CTraceData( );
//	CTraceData( int nTrId, int nPeriod, int nSample, int nGrSize, int *pSvId, int nSvCnt );
	virtual ~CTraceData();

//	void SetTraceData( int nTrId, int nPeriod, int nSample, int nGrSize, int *pSvId, int nSvCnt );
//	void ResetTraceData( );

	UINT uTraceId;
	double dSamplePeriod;
//	int m_nTotalSample;
	UINT uSampleCommand;
	UINT uSampleNo;
	UINT uGroupSize;

	UINT uTraceIdCount;
	BOOL bTraceDataStartReq;
	BOOL bTraceDataStopReq;
	BOOL bTraceDataReportReq;
	int  nTraceList[MAX_TRACE_DATA_NO];
	int	 nS2F23ListSize;

//	int m_nReportGroupSize;
//	int m_nSvCnt;
//	int m_nSampleCnt;
//	int m_nGroupCnt;
//	int *m_pSvId;
//	CString **m_pSvVal; 
};

#endif // !defined(AFX_DICSDATABASE_H__B76AF5E0_F1B7_423C_B146_BC468046625B__INCLUDED_)
