// CommonInterlockSeq.cpp: implementation of the CCommonInterlockSeq class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\Dics.h"
#include "CommonInterlockSeq.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCommonInterlockSeq::CCommonInterlockSeq()
{

}

CCommonInterlockSeq::~CCommonInterlockSeq()
{

}

void CCommonInterlockSeq::InitParameter()
{
	
//	CDicsCommonInterlockSeq::InitParameter();
//	dspcrassus - Mother Sequence Register Ϻκ  ///////////////////////////////////////
	m_nSeqEmoNo			= 0;
	m_nSeqLeakSensorNo	= 0;
	m_nSeqCoverSensorNo	= 0;
	m_nSeqDoorSensorNo	= 0;
	m_nSeqIonizerCondNo = 0;
	m_nSeqFfuCondNo		= 0;
	m_nSeqAkCheckInterlockNo = 0;
	m_nSeqMjCdaCondNo[0]	= 0; // 100908 halesu
	m_nSeqMjCdaCondNo[1]	= 0; // 100908 halesu

	for( int i=0; i<MAX_PARTS_NO; i++ )
	{
		m_nSeqPartsCondNo[i]	= 0;
		m_nSeqPartsUseTimeNo[i] = 0;
	}

	m_pDicsData->m_GenInfo.bEmo				= FALSE;
	m_pDicsData->m_GenInfo.bAreaSensor		= FALSE;
	m_pDicsData->m_GenInfo.bCoverOpen		= FALSE;
	m_pDicsData->m_GenInfo.bDoorOpen		= FALSE;
	m_pDicsData->m_GenInfo.bLeakSensor		= FALSE;
	m_pDicsData->m_GenInfo.bIonizerAlarm	= FALSE;
	m_pDicsData->m_GenInfo.bFfuAlarm		= FALSE;	

	for( int i = 0; i < MAX_CV_NO; i++  )
	{
		m_Interlock.bCvMotorCond[i]	= TRUE;
	}

	m_IniConfiguration.Open( "ProcessData", "Config" );
	CString sEntryName;
	for( int i = 0; i < MAX_PARTS_NO; i++ )
	{
		m_PartsData[i].bPartsCond = TRUE;
		sEntryName.Format( "%s GLS NO", m_pSetupItems->m_infoPartsLifeTimePara[i].sName );
		m_PartsData[i].nGlsCount = m_IniConfiguration.GetIntValue( "PARTS USED GLS NO(EA)", sEntryName, 0 );	// 160425 halesu
		sEntryName.Format( "%s USED TIME", m_pSetupItems->m_infoPartsLifeTimePara[i].sName );
		m_PartsData[i].nUsedTime = m_IniConfiguration.GetIntValue( "PARTS USED TIME(H)", sEntryName, 0 );
	}
///////////////////////////////////////////////////////////////////////////////////////////////////////

	m_nSeqAreaSensorNo	= 0;
	m_nSeqLdDoorInterlockNo = 0;
	m_nSeqUlDoorInterlockNo = 0;

	////////////////////////////// halesu ///////////////////////////////
	for( int i=0; i<MAX_CVSEQ_NO; i++ )	
	{
		m_Timer.bCvSeqTimer[i]		= FALSE;
		m_OldTimer.bCvSeqTimer[i]	= FALSE;
	}
	m_Timer.bPumpSeqTimer		= FALSE;
	m_OldTimer.bPumpSeqTimer	= FALSE;
	m_nSeqTimerNo				= 0;
	///////////////////////////////////////////////////////////////////////
}

BOOL CCommonInterlockSeq::Sequence()
{
	Sleep( 10 );

	SeqEMO();
	SeqLeakSensor();
	SeqCoverSensor();
	SeqDoorSensor();
	SeqCvMotorCondition();
	SeqIonizerCondition();
	SeqFfuCondition();
	SeqRbServoCp();
//	SeqAreaSensor();
	SeqLdDoorInterlock();
#ifndef _NO_UL_HAND
	SeqUlDoorInterlock();
#endif
	SeqAkInterlock();

	for( int i=0; i<MAX_PARTS_NO; i++ )
	{
		SeqPartsUseTime( i );
		SeqPartsCondition( i );
	}

//	SeqTimerCondition();
	SeqMjCdaCondition();
	SeqIFLoaderEmoInterlock();
	SeqScanDevice();	// 240606 halesu
	return TRUE;
}

BOOL CCommonInterlockSeq::GetPartsCheckCond( int nPartsNo )
{
	BOOL bCheck = TRUE;
	switch( nPartsNo ) 
	{
//#ifndef _NO_RB
	case CSetupItems::partsSWR2RB_1:
		bCheck &= m_pDicsView->m_pRbSeq->IsRbMotorRun( 0 );
		break;
	case CSetupItems::partsSWR2RB_2:
		bCheck &= m_pDicsView->m_pRbSeq->IsRbMotorRun( 1 );
		break;
	case CSetupItems::partsSWR2RB_3:
		bCheck &= m_pDicsView->m_pRbSeq->IsRbMotorRun( 2 );
		break;
	case CSetupItems::partsSWR2RB_4:
		bCheck &= m_pDicsView->m_pRbSeq->IsRbMotorRun( 3 );
		break;
	case CSetupItems::partsSWR3RB_1:
		bCheck &= m_pDicsView->m_pRbSeq->IsRbMotorRun( 4 );
		break;
	case CSetupItems::partsSWR3RB_2:
		bCheck &= m_pDicsView->m_pRbSeq->IsRbMotorRun( 5 );
		break;
	case CSetupItems::partsSWR3RB_3:
		bCheck &= m_pDicsView->m_pRbSeq->IsRbMotorRun( 6 );
		break;
	case CSetupItems::partsSWR3RB_4:
		bCheck &= m_pDicsView->m_pRbSeq->IsRbMotorRun( 7 );
		break;
//#endif
	case CSetupItems::partsDI_FILTER1:
	case CSetupItems::partsDI_FILTER2:
		bCheck &= m_pEqpAssy->m_AutoValveSbjDi.GetState();
		break;
	case CSetupItems::partsDI_FILTER3:
		bCheck &= ( m_pEqpAssy->m_DiTank[0].GetPumpOn(0) || m_pEqpAssy->m_DiTank[0].GetPumpOnState(0) || m_pEqpAssy->m_AutoValveDirect.GetState( 0 ) );
		break;
	case CSetupItems::partsDI_FILTER4:
		bCheck &= ( m_pEqpAssy->m_DiTank[1].GetPumpOn(0) || m_pEqpAssy->m_DiTank[1].GetPumpOnState(0) || m_pEqpAssy->m_AutoValveDirect.GetState( 1 ) );
		break;
	case CSetupItems::partsDI_FILTER5:
	case CSetupItems::partsDI_FILTER6:
		bCheck &= m_pEqpAssy->m_AutoValveFrShower.GetState();
		break;
	case CSetupItems::partsCDA_FILTER1:	// Auto Valve  .
		break;
	case CSetupItems::partsCDA_FILTER2:
		bCheck &= m_pEqpAssy->m_AutoValveSbjCda.GetState(0);
		break;
	case CSetupItems::partsCDA_FILTER3:
		bCheck &= m_pEqpAssy->m_AutoValveAkLo.GetState();
		break;
	case CSetupItems::partsCDA_FILTER4:
		bCheck &= m_pEqpAssy->m_AutoValveAkUp.GetState();
		break;
	case CSetupItems::partsCDA_FILTER5:
		bCheck &= m_pEqpAssy->m_AutoValveSbjCda.GetState(1);
		break;
	case CSetupItems::partsCDA_FILTER6:	// Auto Valve  .
		break;
	}
	return bCheck;
}

void CCommonInterlockSeq::SeqAreaSensor()
{
/*
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
	
	int nSeqNo = m_nSeqAreaSensorNo;
	static BOOL bDiStart = FALSE;
	static BOOL bIdleRunning = FALSE;
	static int nAlarmId[MAX_TR_AREA_SENSOR] = { 0, };
	static int nServoNo = 0;
	
	static BOOL bArea[MAX_TR_AREA_SENSOR];
	static DWORD dwTickStart = 0;

	bArea[0] = diTR_UNIT_AREA_SENSOR_FRONT;
	bArea[1] = diTR_UNIT_AREA_SENSOR_REAR;

	m_sSeqName.Format("%s", "AREA    ");

	switch( nSeqNo )
	{
	case 0 :
		dwTickStart = GetTickCount();
		nSeqNo = 3;
		break;

	case 3 :
		if( GetTickCount() - dwTickStart > 1000 )
		{
			nSeqNo = 5;
		}
		break;
	case 5:
#ifndef _MY_DEBUG
		if( bArea[0] || bArea[1] ) 
#else
		if( 0 )
#endif
		{
			// Loader Power Off   // 0. Send the Signal of Loader Power Off.
			// doIF_EMO( TRUE );
			
			// All C/V Stop
			m_pDicsView->m_pCvSeq->CvStopAll();    // 1. C/V Stop (including EUV Off)
			
			// Set the flag
			m_pDicsData->m_GenInfo.bAreaSensor				= TRUE;  // 2. Set Area Flag

			// JUN
//			m_pDicsData->m_GenInfo.bEqpInitComp				= FALSE; 
//			((CDicsView*)m_pOwnerWnd)->m_pPumpSeq->m_SeqFlag.bInitComp = FALSE;
			
			for( int i = 0 ; i < MAX_TR_AREA_SENSOR ; i ++ )
			{
				if( bArea[i] )
				{
					// Set Alarm
					nAlarmId[i] = ALM_AREA_SENSOR_FRONT+i;
					m_pEqpStateSeq->SetAlarm( nAlarmId[i] );
					
					// Log
					m_sMessage.Format( "TR Unit Area%d Alarm", i + 1 );
					SetLog( m_sSeqName, 0, 0, m_sMessage );
				}
			}
			nSeqNo = 30;
		}
		break;
			
	case 30 :
		if( m_pMmc->EStopRbt( RBT_TR_UNIT ) )
		{
			// Set Log
			SetLog( m_sSeqName, 0, 0, "TR Servo E-Stop" );
			nSeqNo = 100;
		}
		break;
		
	case 100 :
#ifndef _MY_DEBUG
		if( !bArea[0] && !bArea[1] ) 
#else
		if( 1 )
#endif
		{
			// Loader Power Off   // 0. Send the Signal of Loader Power Off.
			// doIF_EMO( FALSE );
			
			if( m_pEqpStateSeq->IsPushedAlarmReset() )
			{
				// All C/V Restart
				// CvRestartAll();    // 1. C/V Restart All (including EUV ON)
				// Reset Alarm Message
				for( int i = 0 ; i < MAX_TR_AREA_SENSOR ; i++ )
				{
					if( nAlarmId[i] )
					{
						m_pEqpStateSeq->ResetAlarm( nAlarmId[i] );
						
						// Clear the alarm ID
						nAlarmId[i] = 0;
					}
				}				
				// Set the flag
				m_pDicsData->m_GenInfo.bAreaSensor = FALSE;  // 2. Reset Area Flag

				dwTickStart = GetTickCount();		
				
				// Log
				SetLog( m_sSeqName, 0, 0, "Recovery AREA" );
				nSeqNo = 110;
			}
		}
		break;
		
	case 110:
		if( GetTickCount() - dwTickStart > 2000 )
		{
			nSeqNo = 130;
		}
		break;
	case 130 :
		if( m_pMmc->ResetRbt( RBT_TR_UNIT ) )
		{

			SetLog( m_sSeqName, 0, 0, "TR Servo Reset" );

			nSeqNo = 140;
		}
		break;
	case 140 :
		{
			m_pDicsView->m_pCvSeq->CvRestartAll();
			nSeqNo = 5;
		}		
		break;	
	}

	m_nSeqAreaSensorNo = nSeqNo;
 */
}

void CCommonInterlockSeq::SeqLdDoorInterlock()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	m_sSeqName.Format( "SeqLdDoorInterlock" );
	int nSeqNo = m_nSeqLdDoorInterlockNo;

	static int nAlarmId = 0;
	
	BOOL bNg = FALSE;
	for( int i=0; i<m_pEqpAssy->m_LdSensorDoor.GetDiSize(); i++ )
	{
		int nIndex = CSetupItems::intrDOOR_OPEN1+i;
		bNg = m_pSetupItems->m_nValueDoorIntr[nIndex] && m_pEqpAssy->m_LdSensorDoor.Get( i );
		if( bNg )
		{
			m_pDicsData->m_GenInfo.bLdDoorOpen = TRUE;
			break;
		}
	}   
	switch( nSeqNo )
	{
	case 0:
		if( m_pDicsData->m_GenInfo.bDoorOpen )
		{		
			if( bNg ) nSeqNo = 20;
			else nSeqNo = 0;
		}
		break;
	case 20:
		//hskwak skip/ if( m_pMmc->EStopRbt( RBT_LD_UPDN_UNIT ) )	

		{
			//hskwak skip/ SetLog( m_sSeqName, 0, 0, "LD UPDN UNIT E-STOP" );
			nSeqNo = 30;
		}
		break;
	case 30:
		if( !m_pDicsData->m_GenInfo.bDoorOpen )
		{
			SetLog( m_sSeqName, 0, 0, "DOOR INTERLOCK RECOVERY" );
			m_pDicsData->m_GenInfo.bLdDoorOpen = FALSE;
			nSeqNo = 40;
		}
		break;
	case 40:
		//hskwak skip/if( m_pMmc->ResetRbt( RBT_LD_UPDN_UNIT ) )

		{
			//hskwak skip/SetLog( m_sSeqName, 0, 0, "LD UPDN UNIT RESET" );
			nSeqNo = 0;
		}
		break;
	}
	m_nSeqLdDoorInterlockNo = nSeqNo; 
}
#ifndef _NO_UL_HAND
void CCommonInterlockSeq::SeqUlDoorInterlock()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
	int nSeqNo = m_nSeqUlDoorInterlockNo;
	static int nAlarmId = 0;
	BOOL bNg = FALSE;
	for( int i=0; i<m_pEqpAssy->m_UlSensorDoor.GetDiSize(); i++ )
	{
		//int nIndex = CSetupItems::intrDOOR_OPEN8+i;
		int nIndex = CSetupItems::intrDOOR_OPEN7+i;	// 101124 halesu
		bNg = m_pSetupItems->m_nValueDoorIntr[nIndex] && m_pEqpAssy->m_UlSensorDoor.Get(i);
		if( bNg )
		{
			m_pDicsData->m_GenInfo.bUlDoorOpen = TRUE;
			break;
		}
	}   
	switch( nSeqNo )
	{
	case 0:
		if( m_pDicsData->m_GenInfo.bDoorOpen )
		{
			if( bNg ) nSeqNo = 20;
			else nSeqNo = 0;
		}
		break;
	case 20:
		if( m_pMmc->EStopRbt( RBT_UL_HAND_UNIT ) )
		{
			SetLog( "DOOR INT", 0, 0, "UL Hand Unit E-Stop" );
			nSeqNo = 30;
		}
		break;
	case 30:
		if( !m_pDicsData->m_GenInfo.bDoorOpen )
		{
			SetLog( m_sSeqName, 0, 0, "Door Interlock Recovery" );
			m_pDicsData->m_GenInfo.bUlDoorOpen = FALSE;
			nSeqNo = 50;
		}
		break;
	case 50:
		if( m_pMmc->ResetRbt( RBT_UL_HAND_UNIT ) )

		{
			SetLog( m_sSeqName, 0, 0, "UL Hand Unit Reset" );
			nSeqNo = 0;
		}
		break;
	}
	m_nSeqUlDoorInterlockNo = nSeqNo; 
}
#endif

void CCommonInterlockSeq::SeqIonizerCondition()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	m_sSeqName.Format( "SeqIonizerCondition" );

	static BOOL bInit = FALSE;
	static DWORD dwStartTick = GetTickCount();

	if( !bInit )
	{
		if( GetTickCount() - dwStartTick > 2000 )	bInit = TRUE;
		if( !bInit ) return;
	}

	BOOL bNg = FALSE;
	BOOL bInterlock = FALSE;
 	static int nAlarmId[MAX_IONIZER_NO][MAX_IONIZER_ALM_NO]	= { 0, };

	for( int i=0; i<MAX_IONIZER_NO; i++ )
	{
		int nIndex = CSetupItems::intrIONIZER1 + i;

		for( int k=0; k<MAX_IONIZER_ALM_NO; k++ )
		{
			bNg = m_pSetupItems->m_nValueETCIntr[nIndex] && m_pEqpAssy->m_SignalIonizer.Get( ( i*MAX_IONIZER_ALM_NO + k ) );

			if( bNg && ( nAlarmId[i][k] == 0 ) )
			{
				nAlarmId[i][k] = ALM_IONIZER_ALARM1 + i*MAX_IONIZER_ALM_NO + k;
				m_pEqpStateSeq->SetAlarm( nAlarmId[i][k] );

				m_sMessage.Format( "%s ALARM : SET", m_pSetupItems->m_sItemETCIntr[nIndex] );
				SetLog( m_sSeqName, 0, 0, m_sMessage );
			}
			else if( ( nAlarmId[i][k] != 0 ) && m_pEqpStateSeq->IsPushedAlarmReset() && !bNg )
			{
				m_pEqpStateSeq->ResetAlarm( nAlarmId[i][k] );
				nAlarmId[i][k] = 0;
				m_sMessage.Format( "%s ALARM : RESET", m_pSetupItems->m_sItemETCIntr[nIndex] );
				SetLog( m_sSeqName, 0, 0, m_sMessage );					
			}
				bInterlock |= ( nAlarmId[i][k] !=0 ? TRUE : FALSE );
		}
	}

	if( bInterlock && !m_pDicsData->m_GenInfo.bIonizerAlarm )
	{
		m_pDicsData->m_GenInfo.bIonizerAlarm = TRUE;
#ifndef _MY_DEBUG
		m_pDicsData->m_GenInfo.bCycleStop = TRUE;
#endif		
	}
	else if( !bInterlock && m_pDicsData->m_GenInfo.bIonizerAlarm )
	{
		m_pDicsData->m_GenInfo.bIonizerAlarm = FALSE;	
	} 
}

void CCommonInterlockSeq::ResetPartsData(int nPartsNo)
{
	m_IniConfiguration.Open( "ProcessData", "Config" );

	m_PartsData[nPartsNo].nGlsCount = 0;
	m_PartsData[nPartsNo].nUsedTime = 0;

	CDicsApp* pApp = (CDicsApp*)AfxGetApp();	
	CString sEntryName;
	sEntryName.Format( "%s GLS NO", m_pSetupItems->m_infoPartsLifeTimePara[nPartsNo].sName );
	m_IniConfiguration.SetIntValue( "PARTS USED GLS NO(EA)", sEntryName, m_PartsData[nPartsNo].nGlsCount, TRUE );
	sEntryName.Format( "%s USED TIME", m_pSetupItems->m_infoPartsLifeTimePara[nPartsNo].sName );
	m_IniConfiguration.SetIntValue( "PARTS USED TIME(H)", sEntryName, m_PartsData[nPartsNo].nUsedTime, TRUE );
}

void CCommonInterlockSeq::PartsUsedTimeIncrease(int nPartsNo)
{
	m_IniConfiguration.Open( "ProcessData", "Config" );

	if( GetPartsCheckCond(nPartsNo) )
	{
		m_PartsData[nPartsNo].nUsedTime++;

		CDicsApp* pApp = (CDicsApp*)AfxGetApp();	
		CString sEntryName;
		sEntryName.Format( "%s USED TIME", m_pSetupItems->m_infoPartsLifeTimePara[nPartsNo].sName );
		m_IniConfiguration.SetIntValue( "PARTS USED TIME(H)", sEntryName, m_PartsData[nPartsNo].nUsedTime, TRUE );
	}
}

void CCommonInterlockSeq::PartsGlsCountIncrease(int nPartsNo)
{
	m_IniConfiguration.Open( "ProcessData", "Config" );

	if( GetPartsCheckCond(nPartsNo) )
	{
		m_PartsData[nPartsNo].nGlsCount++;
	
		CDicsApp* pApp = (CDicsApp*)AfxGetApp();	
		CString sEntryName;
		sEntryName.Format( "%s GLS NO", m_pSetupItems->m_infoPartsLifeTimePara[nPartsNo].sName );
		m_IniConfiguration.SetIntValue( "PARTS USED GLS NO(EA)", sEntryName, m_PartsData[nPartsNo].nGlsCount, TRUE );
	}
}

void CCommonInterlockSeq::SeqPartsUseTime(int nPartNo)
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	m_sSeqName.Format( "SeqPartsUseTime%d", nPartNo+1 );

	int i = nPartNo;
	int nSeqNo = m_nSeqPartsUseTimeNo[i];

	DWORD dwPeriod = 1*60*1000;	// 1min

	static DWORD dwTickStart[MAX_PARTS_NO] = { 0, };
	static int	 nTime[MAX_PARTS_NO]	= { 0, };

	switch( nSeqNo )
	{
	case 0:
		dwTickStart[i] = GetTickCount(); 
		nSeqNo = 10;
		break;
	case 10:
		if( GetTickCount() - dwTickStart[i] > dwPeriod ) nSeqNo = 20;
		break;
	case 20:
		{
			if( GetPartsCheckCond(i) )
			{
				nTime[i]++;
#ifndef _MY_DEBUG
				if( nTime[i] * dwPeriod >= 60*60*1000 )	// 1Hour
#else
				if( nTime[i] * dwPeriod >= 60*1000 )
#endif
				{
					PartsUsedTimeIncrease( i );
					nTime[i] = 0;
				}
			}
			nSeqNo = 0;
		}
		break;
	}
	m_nSeqPartsUseTimeNo[i] = nSeqNo;
}

void CCommonInterlockSeq::SeqPartsCondition(int nPartNo)
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	m_sSeqName.Format( "SeqPartsCond%d", nPartNo+1 );

	int i = nPartNo;
	int nSeqNo = m_nSeqPartsCondNo[i];
	
	static DWORD dwTickStart[MAX_PARTS_NO] = { 0, };
	static int 	 nAlarmId[MAX_PARTS_NO] = { 0, };
	
	switch( nSeqNo )
	{
	case 0:
		dwTickStart[i] = GetTickCount(); 
		nSeqNo = 10;
		break;		
	case 10:
		if( GetTickCount() - dwTickStart[i] > 1000 ) nSeqNo = 20;
		break;		
	case 20:
		{
			if( GetPartsCond( i ) )
			{
				nSeqNo = 0;
			}
			else
			{
//#ifndef _NO_RB
//				nAlarmId[i] = ALM_PARTS_LIFE_TIME_OVER1 + MAX_RB_NO + i;
// #else
 				nAlarmId[i] = ALM_PARTS_LIFE_TIME_OVER1 + i;
// #endif
				m_pEqpStateSeq->SetAlarm( nAlarmId[i] );
				m_sMessage.Format( "%s LIFE TIME OVER WARNING", m_pSetupItems->m_infoPartsLifeTimePara[i].sName );
				SetLog( m_sSeqName, 0, 0, m_sMessage );

#ifndef _MY_DEBUG				
//				m_pDicsData->m_GenInfo.bCycleStop = TRUE;
#endif
				nSeqNo = 1000;
			}
		}
		break;		
	case 1000 :
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			SetLog( m_sSeqName, 0, 0, "ALARM RESET" );					
			
			if( !GetPartsCond(i) )
			{
				SetLog( m_sSeqName, 0, 0, "WARNING NOT CLEARED" );
				dwTickStart[i] = GetTickCount();
#ifndef _MY_DEBUG
				m_pDicsData->m_GenInfo.bCycleStop = TRUE;
#endif
				nSeqNo = 1100;
			}
			else
			{
				m_pEqpStateSeq->ResetAlarm( nAlarmId[i] );

				m_sMessage.Format( "%s LIFE TIME OVER RESET", m_pSetupItems->m_infoPartsLifeTimePara[i].sName );
				SetLog( m_sSeqName, 0, 0, m_sMessage );				
				nSeqNo = 0;
			}
		}
		break;		
	case 1100:
		if( ( GetTickCount() - dwTickStart[i] ) >= (DWORD)( 2 * 1000 ) )
		{
			nSeqNo = 1000;
		}
		break;
	}	
	m_nSeqPartsCondNo[i] = nSeqNo;
}

int CCommonInterlockSeq::GetPartsGlsCount(int nPartsNo)
{
	return m_PartsData[nPartsNo].nGlsCount;
}

int CCommonInterlockSeq::GetPartsUsedTime(int nPartsNo)
{
	return m_PartsData[nPartsNo].nUsedTime;
}

void CCommonInterlockSeq::SeqLeakSensor()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	m_sSeqName.Format( "SeqLeakSensor" );

#ifdef _MY_DEBUG
	static BOOL bDebugLeakSensor[MAX_LEAK_SENSOR_NO] = { FALSE, };
#endif

	static BOOL bInit = FALSE;
	static DWORD dwStartTick = GetTickCount();
	if( !bInit )
	{
		if( GetTickCount() - dwStartTick > 2000 )	bInit = TRUE;
		if( !bInit ) return;
	}

	BOOL bNg = FALSE;
	BOOL bInterlock = FALSE;
 	static int nAlarmId[MAX_LEAK_SENSOR_NO]	= { 0, };

	for( int i=0; i<m_pEqpAssy->m_SensorLeak.GetDiSize(); i++ )
	{
		int nIndex = CSetupItems::intrLEAK_SENSOR1 + i;
#ifndef _MY_DEBUG
		bNg = m_pSetupItems->m_nValueLeakDetectIntr[nIndex] && m_pEqpAssy->m_SensorLeak.Get( i );
#else
		bNg = m_pSetupItems->m_nValueLeakDetectIntr[nIndex] && bDebugLeakSensor[i];
#endif

		if( bNg && ( nAlarmId[i] == 0 ) )
		{
			nAlarmId[i] = ALM_LEAK1 + i;
			m_pEqpStateSeq->SetAlarm( nAlarmId[i] );

			m_sMessage.Format( "%s ALARM : SET", m_pSetupItems->m_sItemLeakDetectIntr[nIndex] );
			SetLog( m_sSeqName, 0, 0, m_sMessage );
		}
		else if( ( nAlarmId[i] != 0 ) && m_pEqpStateSeq->IsPushedAlarmReset() && !bNg )
		{
			m_pEqpStateSeq->ResetAlarm( nAlarmId[i] );
			nAlarmId[i] = 0;
			m_sMessage.Format( "%s ALARM : RESET", m_pSetupItems->m_sItemLeakDetectIntr[nIndex] );
			SetLog( m_sSeqName, 0, 0, m_sMessage );					
		}

		bInterlock |= ( nAlarmId[i] !=0 ? TRUE : FALSE );
	}

	if( bInterlock && !m_pDicsData->m_GenInfo.bLeakSensor )
	{
		m_pDicsData->m_GenInfo.bLeakSensor = TRUE;
		m_pDicsView->m_pCvSeq->CvStopAll();			
	}
	else if( !bInterlock && m_pDicsData->m_GenInfo.bLeakSensor )
	{
		m_pDicsData->m_GenInfo.bLeakSensor = FALSE;
		m_pDicsView->m_pCvSeq->CvRestartAll();			
	}
}

void CCommonInterlockSeq::SeqCoverSensor()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	m_sSeqName.Format( "SeqCoverSensor" );

#ifdef _MY_DEBUG
	static BOOL bDebugCoverSensor[MAX_COVER_OPEN_NO] = { FALSE, };
#endif

	static BOOL bInit = FALSE;
	static DWORD dwStartTick = GetTickCount();
	if( !bInit )
	{
		if( GetTickCount() - dwStartTick > 2000 )	bInit = TRUE;
		if( !bInit ) return;
	}

	BOOL bNg = FALSE;
	BOOL bInterlock = FALSE;
	static int nAlarmId[MAX_COVER_OPEN_NO] = { 0, };

	for( int i=0; i<m_pEqpAssy->m_SensorCover.GetDiSize(); i++ )
	{
		int nIndex = CSetupItems::intrCOVER_OPEN1 + i;
#ifndef _MY_DEBUG
		bNg = m_pSetupItems->m_nValueBathCoverIntr[nIndex] && m_pEqpAssy->m_SensorCover.Get( i );
#else
		bNg = m_pSetupItems->m_nValueBathCoverIntr[nIndex] && bDebugCoverSensor[i];
#endif

		if( bNg && ( nAlarmId[i] == 0 ) )
		{
			nAlarmId[i] = ALM_COVER_OPEN1 + i;
			m_pEqpStateSeq->SetAlarm( nAlarmId[i] );

			m_sMessage.Format( "%s ALARM : SET", m_pSetupItems->m_sItemBathCoverIntr[nIndex] );
			SetLog( m_sSeqName, 0, 0, m_sMessage );
		}
		else if( ( nAlarmId[i] != 0 ) && m_pEqpStateSeq->IsPushedAlarmReset() && !bNg )
		{
			m_pEqpStateSeq->ResetAlarm( nAlarmId[i] );
			nAlarmId[i] = 0;
			m_sMessage.Format( "%s ALARM : RESET", m_pSetupItems->m_sItemBathCoverIntr[nIndex] );
			SetLog( m_sSeqName, 0, 0, m_sMessage );					
		}

		bInterlock |= ( nAlarmId[i] !=0 ? TRUE : FALSE );
	}

	if( bInterlock && !m_pDicsData->m_GenInfo.bCoverOpen )
	{
		m_pDicsData->m_GenInfo.bCoverOpen = TRUE;
		m_pDicsView->m_pCvSeq->CvStopAll();					
	}
	else if( !bInterlock && m_pDicsData->m_GenInfo.bCoverOpen )
	{
		m_pDicsData->m_GenInfo.bCoverOpen = FALSE;	
		m_pDicsView->m_pCvSeq->CvRestartAll();					
	}
}


void CCommonInterlockSeq::SeqRbServoCp()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
	
	m_sSeqName.Format( "SeqRbServoCp" );
	
#ifdef _MY_DEBUG
	static BOOL bDebugRbServoCp[8] = { FALSE, };
#endif
	
	static BOOL bInit = FALSE;
	static DWORD dwStartTick = GetTickCount();
	if( !bInit )
	{
		if( GetTickCount() - dwStartTick > 2000 )	bInit = TRUE;
		if( !bInit ) return;
	}
	
	BOOL bNg = FALSE;
	BOOL bInterlock = FALSE;
	static int nAlarmId[8] = { 0, };
	
	for( int i=0; i<m_pEqpAssy->m_RbServoCp.GetDiSize(); i++ )
	{
#ifndef _MY_DEBUG
		bNg = m_pEqpAssy->m_RbServoCp.Get( i );
#else
		bNg = bDebugRbServoCp[i];
#endif
		
		if( bNg && ( nAlarmId[i] == 0 ) )
		{
			nAlarmId[i] = ALM_RB_SERVO_CP1 + i;
			m_pEqpStateSeq->SetAlarm( nAlarmId[i] );
			
		}
		else if( ( nAlarmId[i] != 0 ) && m_pEqpStateSeq->IsPushedAlarmReset() && !bNg )
		{
			m_pEqpStateSeq->ResetAlarm( nAlarmId[i] );
			nAlarmId[i] = 0;
		}
	}
}

void CCommonInterlockSeq::SeqDoorSensor()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	m_sSeqName.Format( "SeqDoorSensor" );

#ifdef _MY_DEBUG
	static BOOL bDebugDoorSensor[MAX_DOOR_OPEN_NO] = { FALSE, };
#endif

	static BOOL bInit = FALSE;
	static DWORD dwStartTick = GetTickCount();
	if( !bInit )
	{
		if( GetTickCount() - dwStartTick > 2000 )	bInit = TRUE;
		if( !bInit ) return;
	}

	BOOL bNg = FALSE;
	BOOL bInterlock = FALSE;
	static int nAlarmId[MAX_DOOR_OPEN_NO] = { 0, };

	for( int i=0; i<m_pEqpAssy->m_SensorDoor.GetDiSize(); i++ )
	{
		int nIndex = CSetupItems::intrDOOR_OPEN1+i;
#ifndef _MY_DEBUG
		bNg = m_pSetupItems->m_nValueDoorIntr[nIndex] && m_pEqpAssy->m_SensorDoor.Get( i );
#else
		bNg = m_pSetupItems->m_nValueDoorIntr[nIndex] && bDebugDoorSensor[i];
#endif

		if( bNg && ( nAlarmId[i] == 0 ) )
		{
			nAlarmId[i] = ALM_DOOR_OPEN1 + i;
			m_pEqpStateSeq->SetAlarm( nAlarmId[i] );

			m_sMessage.Format( "%s ALARM : SET", m_pSetupItems->m_sItemDoorIntr[nIndex] );
			SetLog( m_sSeqName, 0, 0, m_sMessage );
		}
		else if( ( nAlarmId[i] != 0 ) && m_pEqpStateSeq->IsPushedAlarmReset() && !bNg )
		{
			m_pEqpStateSeq->ResetAlarm( nAlarmId[i] );
			nAlarmId[i] = 0;
			m_sMessage.Format( "%s ALARM : RESET", m_pSetupItems->m_sItemDoorIntr[nIndex] );
			SetLog( m_sSeqName, 0, 0, m_sMessage );					
		}

		bInterlock |= ( nAlarmId[i] !=0 ? TRUE : FALSE );
	}

	if( bInterlock && !m_pDicsData->m_GenInfo.bDoorOpen )
	{
		m_pDicsData->m_GenInfo.bDoorOpen = TRUE;
	}
	else if( !bInterlock && m_pDicsData->m_GenInfo.bDoorOpen )
	{
		m_pDicsData->m_GenInfo.bDoorOpen = FALSE;	
	}
}

void CCommonInterlockSeq::SeqFfuCondition()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	m_sSeqName.Format( "SeqFfuCondition" );

#ifdef _MY_DEBUG
	static BOOL bDebugFfuAlarm[MAX_FFU_NO][2] = { { 0, }, };
#endif
	static BOOL bInit = FALSE;
	static DWORD dwStartTick = GetTickCount();
	if( !bInit )
	{
		if( GetTickCount() - dwStartTick > 2000 )	bInit = TRUE;
		if( !bInit ) return;
	}

	if( m_pDicsData->m_GenInfo.bEmo ) return;
	
	BOOL bNg = FALSE;
	BOOL bInterlock = FALSE;
 	static int nAlarmId[MAX_FFU_NO][2]	= { 0, };

	for( int i=0; i<MAX_FFU_NO; i++ )
	{
		int nIndex = CSetupItems::intrFFU1 + i;

		for( int k=0; k<2; k++ )
		{
#ifndef _MY_DEBUG
			bNg = m_pSetupItems->m_nValueFFUAlarmIntr[nIndex] && m_pEqpAssy->m_SignalFfu.Get( ( i*2 + k ) );
#else
			bNg = m_pSetupItems->m_nValueFFUAlarmIntr[nIndex] & bDebugFfuAlarm[i][k];
#endif
			if( bNg && ( nAlarmId[i][k] == 0 ) )
			{
				nAlarmId[i][k] = ALM_FFU_CP_TURN_OFF1 + i*2 + k;
				m_pEqpStateSeq->SetAlarm( nAlarmId[i][k] );
				m_sMessage.Format( "%s ALARM : SET", m_pSetupItems->m_sItemFFUAlarmIntr[nIndex] );
				SetLog( m_sSeqName, 0, 0, m_sMessage );
			}
			else if( ( nAlarmId[i][k] != 0 ) && m_pEqpStateSeq->IsPushedAlarmReset() && !bNg )
			{
				m_pEqpStateSeq->ResetAlarm( nAlarmId[i][k] );
				nAlarmId[i][k] = 0;
				m_sMessage.Format( "%s ALARM : RESET", m_pSetupItems->m_sItemFFUAlarmIntr[nIndex] );
				SetLog( m_sSeqName, 0, 0, m_sMessage );					
			}

			bInterlock |= ( nAlarmId[i][k] !=0 ? TRUE : FALSE );
		}
	}

	if( bInterlock && !m_pDicsData->m_GenInfo.bFfuAlarm )
	{
		m_pDicsData->m_GenInfo.bFfuAlarm = TRUE;
#ifndef _MY_DEBUG
		m_pDicsData->m_GenInfo.bCycleStop = TRUE;
#endif		
	}
	else if( !bInterlock && m_pDicsData->m_GenInfo.bFfuAlarm )
	{
		m_pDicsData->m_GenInfo.bFfuAlarm = FALSE;	
	}
}

void CCommonInterlockSeq::SeqAkInterlock()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
	
	m_sSeqName.Format( "SeqAkInterlock" );

	if( !m_pDicsData->m_GenInfo.bEqpInitComp ) return;

	static int nReturnSeqNo;
	static DWORD dwTickStart;

	int nSeqNo = m_nSeqAkCheckInterlockNo;
	static int nAlarmId = 0;

	double dAkFlowDifference = 0.0;
	double dSetupValueMax = 0.0;
	double dSetupValueMin = 0.0;

	BOOL bCheckCond = TRUE;
	// 150914 halesu
	BOOL bMaxCheck = m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupAK_INTERLOCK];
	BOOL bMinCheck = m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupAK_INTERLOCK2];

//	bCheckCond &= m_pDicsData->m_GenInfo.bAuto;
	bCheckCond &= m_pEqpAssy->m_AutoValveAkLo.GetState();
	bCheckCond &= m_pEqpAssy->m_AutoValveAkUp.GetState();
// 	bCheckCond &= m_pDicsData->m_JobCond.bJobProcessUse;
	bCheckCond &= ( bMaxCheck | bMinCheck );	// 150914 halesu

	dAkFlowDifference = m_pEqpAssy->m_AnalogInputAk.GetRealVal( 0 ) - m_pEqpAssy->m_AnalogInputAk.GetRealVal( 1 );
	dSetupValueMax	=	atof( m_pSetupItems->m_sValueSetup[CSetupItems::setupAK_INTERLOCK] );
	dSetupValueMin	=	atof( m_pSetupItems->m_sValueSetup[CSetupItems::setupAK_INTERLOCK2] );

	switch( nSeqNo )
	{
	case 0:
		if( bCheckCond )
		{
			dwTickStart = GetTickCount();			
			nSeqNo = 10;
		}
		break;
	case 10:
		if( ( GetTickCount() - dwTickStart ) > 3000 )	nSeqNo = 20;
		break;
	case 20:
		if(( bMaxCheck && dAkFlowDifference > dSetupValueMax ) ||
		   ( bMinCheck && dAkFlowDifference < dSetupValueMin ))
		{
			dwTickStart = GetTickCount();
			nSeqNo = 30;
		}
		else if( !bCheckCond ) nSeqNo = 0;
		break;
	case 30:	 
		if( ( GetTickCount() - dwTickStart ) > 2000 )
		{
			if( bCheckCond && 
			  (( bMaxCheck && dAkFlowDifference > dSetupValueMax ) ||
			   ( bMinCheck && dAkFlowDifference < dSetupValueMin )))
			{
				m_pDicsData->m_GenInfo.bAkInterlock = TRUE;

				nAlarmId = ALM_AK_FLOW_DEVIATION;
				m_pEqpStateSeq->SetAlarm( nAlarmId );

				CString sMessage;
				sMessage.Format("AK FLOW DEVIATION ALARM : SET ( %f )", dAkFlowDifference );
				
				SetLog( m_sSeqName, 0, 0, sMessage );		
				nReturnSeqNo = nSeqNo;		
				nSeqNo = 1000;
			}
			else
			{
				m_pDicsData->m_GenInfo.bAkInterlock = FALSE;
				nSeqNo = 0;
			}
		}		
		break;
	case 1000 :
		if( m_pEqpStateSeq->IsPushedAlarmReset() && 
			( !bCheckCond ||
			(( bMaxCheck && dAkFlowDifference <= dSetupValueMax ) &&
			 ( bMinCheck && dAkFlowDifference >= dSetupValueMin ))))
		{
			SetLog( m_sSeqName, 0, 0, "AK FLOW DEVIATION ALARM : RESET" );
			m_pEqpStateSeq->ResetAlarm( nAlarmId );
			nSeqNo = nReturnSeqNo;
		}
		break;
	}
	m_nSeqAkCheckInterlockNo = nSeqNo;	
}

void CCommonInterlockSeq::SeqTimerCondition()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

///////////////////////////////////////////////////////////////////////////////
	static BOOL bInit = FALSE;
	static DWORD dwStartTick = GetTickCount();
	if( !bInit )
	{
		if( GetTickCount() - dwStartTick > 2000 )
		{
			m_pEqpAssy->m_TimerStart.Set(0, ON);
			bInit = TRUE;		
		}
		if( !bInit ) return;
	}
///////////////////////////////////////////////////////////////////////////////

	int nSeqNo = m_nSeqTimerNo;

	BOOL bTimerStart = TRUE;
	BOOL bReset = TRUE;
	static BOOL bTimerReset[MAX_TIMER_PART_NO] = { FALSE, };
	static BOOL bTimerPartCheck[MAX_TIMER_PART_NO] = { FALSE, };
	DWORD nTimerResetTime = atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupTIMER_RESET_TIME] );

	for( int i=0; i<MAX_TIMER_PART_NO; i++ )	
	{
		if( m_Timer.bCvSeqTimer[i] ) 
		{
			m_Timer.bCvSeqTimer[i]	= FALSE;
			bTimerPartCheck[i]		= TRUE;
		}
	}
/*		// 20100706 ssm 
	if( m_Timer.bPumpSeqTimer ) 
	{
		m_Timer.bPumpSeqTimer		= FALSE;
		bTimerPartCheck[timerPUMP]	= TRUE;
	}
*/	
	for( int i=0; i<MAX_TIMER_PART_NO; i++ ) 
	{
		if( bTimerPartCheck[i] )	bTimerReset[i] = TRUE;
		bReset &= bTimerReset[i];
	}

	switch( nSeqNo )
	{
	case 0:
		{
			dwStartTick = GetTickCount();
			
			nSeqNo = 10;
		}
		break;
	case 10:
		if( GetTickCount() - dwStartTick > nTimerResetTime )
		{
			if( bReset )
			{
				bReset = FALSE;
				m_pEqpAssy->m_TimerReset.Set(0, ON);

//				SetLog( "Timer Test", 0, 0, "Timer ON" );	// 20100706 ssm Test
				for( int i=0; i<MAX_TIMER_PART_NO; i++ )
				{
					bTimerReset[i]		= FALSE;
					bTimerPartCheck[i]	= FALSE;
				}
				dwStartTick = GetTickCount();

				nSeqNo = 20;
			}
		}
		break;
	case 20:
		if( GetTickCount() - dwStartTick > 10 )
		{
			m_pEqpAssy->m_TimerReset.Set(0, OFF);
//			SetLog( "Timer Test", 0, 0, "Timer OFF" );		// 20100706 ssm Test
			dwStartTick = GetTickCount();
			nSeqNo = 0;
		}
		break;
	}

	m_nSeqTimerNo = nSeqNo;
}

void CCommonInterlockSeq::SetTimerPart(int nPart, BOOL bOn)
{
	if( nPart == 0 ) m_Timer.bCvSeqTimer[timerUP_CV]		= bOn;
	else if( nPart == 1 ) m_Timer.bCvSeqTimer[timerLO_CV]	= bOn;
	else if( nPart == 2 ) m_Timer.bCvSeqTimer[timerPUMP]	= bOn;
}

void CCommonInterlockSeq::SeqMjCdaCondition()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;

	if( !m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE] ||
		!m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupSWR1_SBJ_USE] )
	{
		m_pDicsData->m_GenInfo.bMjCdaReady[0] = TRUE;
		m_pDicsData->m_GenInfo.bMjCdaReady[1] = TRUE;
		return;
	}
#else
	m_pDicsData->m_GenInfo.bMjCdaReady[0] = TRUE;
	m_pDicsData->m_GenInfo.bMjCdaReady[1] = TRUE;
	return;
#endif

	static BOOL bInit = FALSE;
	static DWORD dwStartTick = GetTickCount();
	static DWORD dwStartT[2];

	if( !bInit )
	{
		if( GetTickCount() - dwStartTick > 2000 )	bInit = TRUE;
		if( !bInit ) return;
	}

	// 150903 halesu
    BOOL bCdaReady[2] = { TRUE, TRUE };
	BOOL bCdaCheck = m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupMJ_CDA_PRESSURE_CHECK];
	double dCdaPress = atof( m_pSetupItems->m_sValueSetup[CSetupItems::setupMJ_CDA_PRESSURE_CHECK] );

	if( bCdaCheck )
	{
		bCdaReady[0] = ((double) m_pEqpAssy->m_AnalogInput.GetRealVal( 9 )) > dCdaPress ? TRUE : FALSE;  // MJ1 CDA PRESS
		bCdaReady[1] = ((double) m_pEqpAssy->m_AnalogInput.GetRealVal( 10 )) > dCdaPress ? TRUE : FALSE;  // MJ2 CDA PRESS
	}

	int nSeqNo[2];
	nSeqNo[0] = m_nSeqMjCdaCondNo[0];
	nSeqNo[1] = m_nSeqMjCdaCondNo[1];
	
	for( int i=0; i<2; i++ )
	{
		switch( nSeqNo[i] )
		{
			case 0:
				if( bCdaReady[i] ) 
				{
					dwStartT[i] = GetTickCount();
					nSeqNo[i] = 10;
				}
				else 
				{
					m_pDicsData->m_GenInfo.bMjCdaReady[i] = FALSE;
				}
				break;
			case 10:
				if( bCdaReady[i] && ( GetTickCount() - dwStartT[i] ) > 1000 )
				{
					m_pDicsData->m_GenInfo.bMjCdaReady[i] = TRUE;
					nSeqNo[i] = 0;
				}
				else if ( !bCdaReady[i] )
				{
					m_pDicsData->m_GenInfo.bMjCdaReady[i] = FALSE;
					nSeqNo[i] = 0;
				}
				break;
		}
		m_nSeqMjCdaCondNo[i] = nSeqNo[i];
	}
}

void CCommonInterlockSeq::SeqIFLoaderEmoInterlock()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#else
	m_pDicsData->m_GenInfo.bIFLoaderEmoInterlock = FALSE;
	return;
#endif
	
	m_sSeqName.Format( "SeqIFLoaderEmoInterlock" );
	
	static BOOL bInit = FALSE;
	static DWORD dwStartTick = GetTickCount();
	if( !bInit )
	{
		if( GetTickCount() - dwStartTick > 2000 )	bInit = TRUE;
		if( !bInit ) return;
	}
	
	BOOL bNg = FALSE;
	BOOL bInterlock = FALSE;
	static int nAlarmId[MAX_IF_LOADER_EMO] = { 0, };
	
	for( int i=0; i<m_pEqpAssy->m_IFLoaderEmo.GetDiSize(); i++ )
	{
		bNg = m_pEqpAssy->m_IFLoaderEmo.Get( i );
		
		if( bNg && ( nAlarmId[i] == 0 ) )
		{
			nAlarmId[i] = ALM_LOADER_EMO1 + i;
			m_pEqpStateSeq->SetAlarm( nAlarmId[i] );
			
			m_sMessage.Format( "IF LOADER EMO%d ALARM : SET", i+1 );
			SetLog( m_sSeqName, 0, 0, m_sMessage );
		}
		else if( ( nAlarmId[i] != 0 ) && m_pEqpStateSeq->IsPushedAlarmReset() && !bNg )
		{
			m_pEqpStateSeq->ResetAlarm( nAlarmId[i] );
			nAlarmId[i] = 0;
			m_sMessage.Format( "IF LOADER EMO%d ALARM : RESET", i+1 );
			SetLog( m_sSeqName, 0, 0, m_sMessage );					
		}
		
		bInterlock |= ( nAlarmId[i] !=0 ? TRUE : FALSE );
	}
	
	if( bInterlock && !m_pDicsData->m_GenInfo.bIFLoaderEmoInterlock )
	{
		m_pDicsData->m_GenInfo.bIFLoaderEmoInterlock = TRUE;
		m_pDicsData->m_GenInfo.bCycleStop = TRUE;
	}
	else if( !bInterlock && m_pDicsData->m_GenInfo.bIFLoaderEmoInterlock )
	{
		m_pDicsData->m_GenInfo.bIFLoaderEmoInterlock = FALSE;	
	}
}

void CCommonInterlockSeq::SeqScanDevice()	// 240606 halesu
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	m_sSeqName.Format( "SeqScanDevice" );

	static BOOL bInit = FALSE;
	static DWORD dwStartTick = GetTickCount();
	if( !bInit )
	{
		if( GetTickCount() - dwStartTick > 10000 )	bInit = TRUE;
		if( !bInit ) return;
	}

	BOOL bNg = FALSE;
	BOOL bInterlock = FALSE;
	static int nAlarmId;

	bNg = m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupBUF_UNIT_SCAN_SENSOR] && m_pDicsData->m_GenInfo.bScanDeviceAlarmCheck;

	if( bNg && ( nAlarmId == 0 ) )
	{
		nAlarmId = ALM_BUF_UNIT_SCAN_SENSOR;
		m_pEqpStateSeq->SetAlarm( nAlarmId );

		m_sMessage.Format( "BUF UNIT SCAN SENSOR ALARM : SET");
		SetLog( m_sSeqName, 0, 0, m_sMessage );
	}
	else if( ( nAlarmId != 0 ) && m_pEqpStateSeq->IsPushedAlarmReset() && !bNg )
	{
		m_pEqpStateSeq->ResetAlarm( nAlarmId );
		nAlarmId = 0;
		m_sMessage.Format( "BUF UNIT SCAN SENSOR ALARM : RESET");
		SetLog( m_sSeqName, 0, 0, m_sMessage );					
	}
	bInterlock |= ( nAlarmId !=0 ? TRUE : FALSE );
	
	if( bInterlock && !m_pDicsData->m_GenInfo.bScanDeviceAlarm )
	{
		m_pDicsData->m_GenInfo.bScanDeviceAlarm = TRUE;
		m_pDicsData->m_GenInfo.bCycleStop = TRUE;
	}
	else if( !bInterlock && m_pDicsData->m_GenInfo.bScanDeviceAlarm )
	{
		m_pDicsData->m_GenInfo.bScanDeviceAlarm = FALSE;	
	}
}
