// SetupItems.cpp: implementation of the CSetupItems class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\Dics.h"
#include "SetupItems.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//--------------------------------------------------------------------
// Col 0 : Item Name
// Col 1 : Process / Pass Mode, Use, No Use
//			- optionBOOL1 : PROCESS MODE / PASS MODE
//			- optionBOOL2 : USE / NO USE
//			- optionBOOL3 : CHECK / NO CHECK
//			- optionBOOL4 : CW / CCW
//			- optionBOOL5 : ACTIVE / PASSIVE
//			- optionBOOL6 : CHECK / NO CHECK + VALUE
// Col 2 : Value
//--------------------------------------------------------------------
SETUP_INFO CSetupItems::m_infoSetup[] = 
{
	{ "PUMP1 USE",					optionBOOL2,	formatNONE,		"NONE"	},
	{ "PUMP2 USE",					optionBOOL2,	formatNONE,		"NONE"	},	//hskwak 2019.05.13 ߰.
#ifdef _BUFTANK_USE
	{ "BUFTANK PUMP USE",			optionBOOL2,	formatNONE,		"NONE"	},
#endif
	{ "SWR1 MJ USE",				optionBOOL2,	formatNONE,		"NONE"	},
	{ "SWR4 MJ USE",				optionBOOL2,	formatNONE,		"NONE"	},	//hskwak 2019.05.13 ߰.
	{ "LD FIX BROKEN",				optionBOOL3,	formatNONE,		"NONE"  },	//hskwak 2019.06.22 ߰.
	{ "LD SCAN BROKEN",				optionBOOL3,	formatNONE,		"NONE"  },	//hskwak 2019.06.22 ߰.
	{ "UL FIX BROKEN",				optionBOOL3,	formatNONE,		"NONE"  },
	{ "UL SCAN BROKEN",				optionBOOL3,	formatNONE,		"NONE"  },
	{ "BUF SCAN BROKEN",			optionBOOL3,	formatNONE,		"NONE"  },	// 240606 halesu
	{ "UL CV ACCEL SPEED",			optionNONE,		formatDIGIT,	"mm/min"},	//hskwak 2019.05.13 ߰.	// ġ 츮 ߿ ο ߾ Ѵ. AK  ġ .
	{ "UL CV DECEL SPEED",			optionNONE,		formatDIGIT,	"mm/min"},
	{ "GLASS SIZE",					optionNONE,		formatDIGIT,	"mm"	},
	{ "MAX GLASS NO",				optionNONE,		formatDIGIT,	"EA"	}, 	
	{ "CV TIMEOUT DISTANCE",		optionNONE,		formatDIGIT,	"mm"	},
	{ "LD CV GLS STOP DISTANCE",	optionNONE,		formatDIGIT,	"mm"	}, 
	{ "UL CV GLS STOP DISTANCE",	optionNONE,		formatDIGIT,	"mm"	}, 
	{ "PUMP INTERLOCK CHK TIME",	optionNONE,		formatDIGIT,	"Sec"	}, 	//    üũ Ȯ  ON ϰ    ð Delay.  5  0ʸ ٷ ˶
	{ "PUMP INTERLOCK FLOW RATE",	optionNONE,		formatDIGIT,	"lpm"	},  // 1 AUTO VALVE ON     հ.
	{ "INITIALIZE TIMEOUT",			optionNONE,		formatDIGIT,	"sec"	},	// ʱȭ   Ϸ ɶ ð.
	{ "LEVEL SENSOR CONFIRM TIME",	optionNONE,		formatDIGIT,	"sec"	},  // TANK Level üũ ش ð Ŀ üũϵ Ѵ. ʱ 1ȸ. IO д Task Check ÿ Ǹ б  check   Ƿ ʱȭ  1  Ų.
	{ "IDLE MODE WAIT TIME",		optionNONE,		formatDIGIT,	"min"	},	// Glass   Process, Glass  츦 IDLE̴. IDLE STOP GLASS   . IDLE  ħ ʰ,     Ƿ, ȯ̳, ȯ Ű 츦 IDLE RUN̶ Ѵ. Glass   ðŭ  IDLE Mode Ѵ.
	{ "AK FLOW DEVIATION MAX",		optionBOOL6,	formatDIGIT,	"lpm"	},	// 150914 halesu	// 500 . Air Knife Conveyor ǵ ۵ ȴ.  AK 500Ipm ̰  ȵǰ, 50lpm ̻ ; Ѵ.  Conveyor Ǹ ޴̾ AK ۵ ȴ.
	{ "AK FLOW DEVIATION MIN",		optionBOOL6,	formatDIGIT,	"lpm"	},	// 150914 halesu	// 50 . Interlock Set ȳ  Manual  ؼ ̴.
	{ "MJ CDA PRESSURE CHK",		optionBOOL6,	formatDIGIT,	"kpa"	},	// 150903 halesu	// Auto Value OFF Ǿ ̼ϰ  ִ Ȯο.
	{ "WAIT IN WET CHAMBER USE",	optionBOOL2,	formatNONE,		"NONE"	},	// 160704 halesu
	{ "UL WAIT ON DELAY TIME",		optionNONE,		formatDIGIT,	"sec"	},	// 160704 halesu	// Outcv GLASS ϰ Robot   ð ð.  GLS 浹   Ƿ.
	{ "SWR2 UP RB1 Servo Use",		optionBOOL2,	formatNONE,		"NONE"	},
	{ "SWR2 LO RB1 Servo Use",		optionBOOL2,	formatNONE,		"NONE"	},
 	{ "SWR2 UP RB2 Servo Use",		optionBOOL2,	formatNONE,		"NONE"	},
	{ "SWR2 LO RB2 Servo Use",		optionBOOL2,	formatNONE,		"NONE"	},
	{ "SWR3 UP RB1 Servo Use",		optionBOOL2,	formatNONE,		"NONE"	},
	{ "SWR3 LO RB1 Servo Use",		optionBOOL2,	formatNONE,		"NONE"	},	//hskwak 2019.05.13 ߰.
 	{ "SWR3 UP RB2 Servo Use",		optionBOOL2,	formatNONE,		"NONE"	},	//hskwak 2019.05.13 ߰.
	{ "SWR3 LO RB2 Servo Use",		optionBOOL2,	formatNONE,		"NONE"	},	//hskwak 2019.05.13 ߰.
	{ "GAUGE CHK DEALY TIME",		optionNONE,		formatDIGIT,	"sec"	},	// 160721 halesu	//  Gauge ON   Ȯ ϱ  Delay Time
	{ "WR CHK DEALY TIME",			optionNONE,		formatDIGIT,	"sec"	},	// 160721 halesu	//  WR ON   Ȯ ϱ  Delay Time
	{ "LD ALIGN CYL TIMEOUT",		optionNONE,		formatDIGIT,	"sec"	},	// 190514 hskwak	// Cylinder  Time Out
	{ "UL ALIGN CYL TIMEOUT",		optionNONE,		formatDIGIT,	"sec"	},	// 190514 hskwak	// Cylinder  Time Out
	{ "UL ALIGN UD CYL TIMEOUT",	optionNONE,		formatDIGIT,	"sec"	},	// 190514 hskwak	// Cylinder  Time Out
	{ "UL PIN UD CYL TIMEOUT",		optionNONE,		formatDIGIT,	"sec"	},	// 190514 hskwak	// Cylinder  Time Out
	{ "UL Timeout Pump Off Delay",	optionNONE,		formatDIGIT,	"sec"	},	// Thomas 201208, Unloading timeout pump off delay
	{ "UL Align BW Pin UP Use",		optionBOOL2,	formatNONE,		"NONE"	},	// 240614 halesu
};

CString CSetupItems::m_sItemInSensorOffTimeOut[] = 	
{	
	"INCV IN",
	"SWR1 IN",
	"SWR2 IN",
	"SWR3 IN",
	"SWR4 IN",
	"AK IN",
	"BUF IN",
	"OUTCV IN",
};		
	
CString CSetupItems::m_sItemOutSensorOffTimeOut[] = 	
{	
	"INCV OUT",
	"SWR1 OUT",
	"SWR2 OUT",
	"SWR3 OUT",
	"SWR4 OUT",
	"AK OUT",
	"BUF OUT",
	"OUTCV OUT",
};		
	
CString CSetupItems::m_sItemInSensorSkip[] = 	
{	
	"INCV IN OP",
	"SWR1 IN OP",
	"SWR2 IN OP",
	"SWR3 IN OP",
	"SWR4 IN OP",
	"AK IN OP",
	"BUF IN OP",
	"OUTCV IN OP",
};		
	
CString CSetupItems::m_sItemOutSensorSkip[] = 	
{	
	"INCV OUT OP",
	"SWR1 OUT OP",
	"SWR2 OUT OP",
	"SWR3 OUT OP",
	"SWR4 OUT OP",
	"AK OUT OP",
	"BUF OUT OP",
	"OUTCV OUT OP",
};	
		
CString CSetupItems::m_sItemSubInSensorSkip[] = 	
{	
	"INCV IN MT",
	"SWR1 IN MT",
	"SWR2 IN MT",
	"SWR3 IN MT",
	"SWR4 IN MT",
	"AK IN MT",
	"BUF IN MT",
	"OUTCV IN MT",
};		
	
CString CSetupItems::m_sItemSubOutSensorSkip[] = 	
{	
	"INCV OUT MT",
	"SWR1 OUT MT",
	"SWR2 OUT MT",
	"SWR3 OUT MT",
	"SWR4 OUT MT",
	"AK OUT MT",
	"BUF OUT MT",
	"OUTCV OUT MT",
};	

SETUP_INFO CSetupItems::m_infoIdleRun[] = 
{
	{ "IDLE MODE USE",			optionBOOL2,	formatNONE,		"NONE" },		// IDLE Time  Y/N,	NOUSE ÿ  PUMP Ű Ѵ.
	{ "RUN TIME",				optionNONE,		formatDIGIT,	"sec" },		// IDLE Time  RuN ð 
	{ "STOP TIME",				optionNONE,		formatDIGIT,	"min" },		// IDLE TIME  RUN  ߴ ð.
	{ "SWR2 Upper RB1 DIR",		optionBOOL4,	formatNONE,		"NONE" },
	{ "SWR2 Lower RB1 DIR",		optionBOOL4,	formatNONE,		"NONE" },
 	{ "SWR2 Upper RB2 DIR",		optionBOOL4,	formatNONE,		"NONE" },
	{ "SWR2 Lower RB2 DIR",		optionBOOL4,	formatNONE,		"NONE" },
	{ "SWR3 Upper RB1 DIR",		optionBOOL4,	formatNONE,		"NONE" },
	{ "SWR3 Lower RB1 DIR",		optionBOOL4,	formatNONE,		"NONE" },
 	{ "SWR3 Upper RB2 DIR",		optionBOOL4,	formatNONE,		"NONE" },
	{ "SWR3 Lower RB2 DIR",		optionBOOL4,	formatNONE,		"NONE" },
 	{ "SWR2 Upper RB1 Speed",	optionNONE,		formatDIGIT,	"rpm" },
	{ "SWR2 Lower RB1 Speed",	optionNONE,		formatDIGIT,	"rpm" },
	{ "SWR2 Upper RB2 Speed",	optionNONE,		formatDIGIT,	"rpm" },
	{ "SWR2 Lower RB2 Speed",	optionNONE,		formatDIGIT,	"rpm" },
	{ "SWR3 Upper RB1 Speed",	optionNONE,		formatDIGIT,	"rpm" },
	{ "SWR3 Lower RB1 Speed",	optionNONE,		formatDIGIT,	"rpm" },
	{ "SWR3 Upper RB2 Speed",	optionNONE,		formatDIGIT,	"rpm" },
	{ "SWR3 Lower RB2 Speed",	optionNONE,		formatDIGIT,	"rpm" },
	{ "SWR2 Upper RB1 Gap",		optionNONE,		formatFLOAT,	"mm" },	// 170714 halesu
	{ "SWR2 Lower RB1 Gap",		optionNONE,		formatFLOAT,	"mm" }, // 170714 halesu
	{ "SWR2 Upper RB2 Gap",		optionNONE,		formatFLOAT,	"mm" }, // 170714 halesu
	{ "SWR2 Lower RB2 Gap",		optionNONE,		formatFLOAT,	"mm" }, // 170714 halesu
	{ "SWR3 Upper RB1 Gap",		optionNONE,		formatFLOAT,	"mm" },
	{ "SWR3 Lower RB1 Gap",		optionNONE,		formatFLOAT,	"mm" },
	{ "SWR3 Upper RB2 Gap",		optionNONE,		formatFLOAT,	"mm" },
	{ "SWR3 Lower RB2 Gap",		optionNONE,		formatFLOAT,	"mm" },
};

CString CSetupItems::m_sNameTankLevel[] = 
{
	"DI TANK LEVEL HH",		// Simulation ÿ .
	"DI TANK LEVEL H",
	"DI TANK LEVEL L",
	"DI TANK LEVEL LL",

#ifdef _BUFTANK_USE
	"DI BUFTANK LEVEL HH",
	"DI BUFTANK LEVEL H",
	"DI BUFTANK LEVEL L",
	"DI BUFTANK LEVEL LL",
#endif
};

CString CSetupItems::m_sItemBathCoverIntr[] = 
{
	"SWR1 BDOOR OP OPEN",
	"SWR1 BDOOR MT OPEN",
	"SWR2 BDOOR OP1 OPEN",
	"SWR2 BDOOR MT1 OPEN",
	"SWR2 BDOOR OP2 OPEN",
	"SWR2 BDOOR MT2 OPEN",
	"SWR3 BDOOR OP1 OPEN",
	"SWR3 BDOOR MT1 OPEN",
	"SWR3 BDOOR OP2 OPEN",
	"SWR3 BDOOR MT2 OPEN",
	"SWR4 BDOOR OP OPEN",
	"SWR4 BDOOR MT OPEN",
	"AK BDOOR OP1 OPEN",
	"AK BDOOR MT1 OPEN",
	"AK BDOOR OP2 OPEN",
	"AK BDOOR MT2 OPEN",
};

CString CSetupItems::m_sItemDoorIntr[] = 
{
	"INCV FDOOR OPEN LOW OP1 OPEN",
	"INCV FDOOR OPEN LOW OP2 OPEN",
	"INCV FDOOR OPEN LOW MT1 OPEN",
	"INCV FDOOR OPEN LOW MT2 OPEN",
	"INCV FDOOR OPEN MID OP1 OPEN",
	"INCV FDOOR OPEN MID OP2 OPEN",
	"INCV FDOOR OPEN MID OP3 OPEN",
	"INCV FDOOR OPEN MID OP4 OPEN",
	"INCV FDOOR OPEN MID MT1 OPEN",
	"INCV FDOOR OPEN MID MT2 OPEN",
	"INCV FDOOR OPEN MID MT3 OPEN",
	"INCV FDOOR OPEN MID MT4 OPEN",
	"SWR1 FDOOR OPEN LOW OP1 OPEN",
	"SWR1 FDOOR OPEN LOW OP2 OPEN",
	"SWR1 FDOOR OPEN LOW MT1 OPEN",
	"SWR1 FDOOR OPEN LOW MT2 OPEN",
	"SWR2 FDOOR OPEN LOW OP1 OPEN",
	"SWR2 FDOOR OPEN LOW OP2 OPEN",
	"SWR2 FDOOR OPEN LOW MT1 OPEN",
	"SWR2 FDOOR OPEN LOW MT2 OPEN",
	"SWR3 FDOOR OPEN LOW OP1 OPEN",
	"SWR3 FDOOR OPEN LOW OP2 OPEN",
	"SWR3 FDOOR OPEN LOW MT1 OPEN",
	"SWR3 FDOOR OPEN LOW MT2 OPEN",
	"SWR4 FDOOR OPEN LOW OP1 OPEN",
	"SWR4 FDOOR OPEN LOW OP2 OPEN",
	"SWR4 FDOOR OPEN LOW MT1 OPEN",
	"SWR4 FDOOR OPEN LOW MT2 OPEN",
	"AK FDOOR OPEN LOW OP1 OPEN",
	"AK FDOOR OPEN LOW OP2 OPEN",
	"AK FDOOR OPEN LOW MT1 OPEN",
	"AK FDOOR OPEN LOW MT2 OPEN",
	"BUF FDOOR OPEN LOW MT1 OPEN",
	"BUF FDOOR OPEN LOW MT2 OPEN",
	"BUF FDOOR OPEN MID MT1 OPEN",
	"BUF FDOOR OPEN MID MT2 OPEN",
	"OUTCV FDOOR OPEN LOW MT1 OPEN",
	"OUTCV FDOOR OPEN LOW MT2 OPEN",
	"OUTCV FDOOR OPEN LOW MT3 OPEN",
	"OUTCV FDOOR OPEN LOW MT4 OPEN",
	"OUTCV FDOOR OPEN MID MT1 OPEN",
	"OUTCV FDOOR OPEN MID MT2 OPEN",
	"OUTCV FDOOR OPEN MID MT3 OPEN",
	"OUTCV FDOOR OPEN MID MT4 OPEN",
};

CString CSetupItems::m_sItemLeakDetectIntr[] = 
{
	// 151120 halesu 
	"SWR2 LEAK DETECT",
	"SWR4 LEAK DETECT",
	"AK LEAK DETECT",
	"SWR2 OP LEAK DETECT",
	"SWR4 OP LEAK DETECT",
	"AK OP LEAK DETECT",
#ifdef _BUFTANK_USE
	"BUFTANK LEAK DETECT",
#endif
};

CString CSetupItems::m_sItemFFUAlarmIntr[] = 
{ 
	"INCV FFU1",
	"INCV FFU2",
	"INCV FFU3",
	"AK HEPA",
	"OUTCV FFU1",
	"OUTCV FFU2",
	"OUTCV FFU3",
};

CString CSetupItems::m_sItemBrokenIntr[] = 
{
	"UL Unit Broken1",	
	"UL Unit Broken2",
	"UL Unit Broken3",
	"UL Unit Broken4",
	"UL Unit Broken All",
	"UL Unit Broken Scan",
};

CString CSetupItems::m_sItemETCIntr[] = 
{
	"INCV IONIZER",
	"BUF IONIZER",
};

SETUP_INFO CSetupItems::m_infoGaugeLimit[] = 
{
	{ "SWR1_UNIT_CDA_IN_INCV_ION",			optionBOOL3, formatDIGIT, "Kpa" },	// 1
	{ "SWR1_UNIT_CDA_IN_SWR1_UP_AC",		optionBOOL3, formatDIGIT, "Kpa" },	// 2
	{ "SWR1_UNIT_CDA_IN_SWR1_LO_AC",		optionBOOL3, formatDIGIT, "Kpa" },	// 3
	{ "SWR1_UNIT_CDA_IN_ION_AND_AC_IN_FT",	optionBOOL3, formatDIGIT, "Kpa" },	// 4
	{ "SWR1_UNIT_CDA_IN_SWR1_UP_MJ",		optionBOOL3, formatDIGIT, "Kpa" },	// 5
	{ "SWR1_UNIT_CDA_IN_SWR1_LO_MJ",		optionBOOL3, formatDIGIT, "Kpa" },	// 6
	{ "SWR1_UNIT_CDA_IN_SWR1_MJ_IN_FT",		optionBOOL3, formatDIGIT, "Kpa" },	// 7
	{ "SWR1_UNIT_DI_SPL_IN_FT",				optionBOOL3, formatDIGIT, "lpm" },	// 8
	{ "SWR1_UNIT_CDA_IN_SWR1_UP_MJ_FL",		optionBOOL3, formatDIGIT, "lpm" },	// 9
	{ "SWR1_UNIT_CDA_IN_SWR1_LO_MJ_FL",		optionBOOL3, formatDIGIT, "lpm" }, 	// 10
	{ "SWR1_UNIT_DI_SPL_AK_FL",				optionBOOL3, formatDIGIT, "lpm"	},	// 11
	{ "SWR1_UNIT_DI_SPL_UP_MJ_FL",			optionBOOL3, formatDIGIT, "lpm"	},	// 12
	{ "SWR1_UNIT_DI_SPL_LO_MJ_FL",			optionBOOL3, formatDIGIT, "lpm" },	// 13
	{ "SWR1_UNIT_DI_SPL_IN_FT_FL",			optionBOOL3, formatDIGIT, "lpm" },	// 14
	{ "SWR1_UNIT_DI_SPL_LO_FL",				optionBOOL3, formatDIGIT, "lpm" },	// 15
	{ "SWR1_UNIT_DI_SPL_UP_FL",				optionBOOL3, formatDIGIT, "lpm" },	// 16
	{ "SWR1_UNIT_DI_SPL_WR",				optionBOOL3, formatDIGIT, "Moh" },	// 17
	{ "SWR1_UNIT_EXH_DM",					optionBOOL3, formatDIGIT, "Pa" },	// 18
	{ "SWR2_UNIT_DI_IN_FT_PG",				optionBOOL3, formatDIGIT, "Kpa" },	// 19
	{ "SWR2_UNIT_DI_RETURN_FL",				optionBOOL3, formatDIGIT, "lpm" },	// 20
	{ "SWR2_UNIT_DI_SPL_LO_FL",				optionBOOL3, formatDIGIT, "lpm" },	// 21
	{ "SWR2_UNIT_DI_SPL_FL",				optionBOOL3, formatDIGIT, "lpm" },	// 22
	{ "SWR2_UNIT_DI_SPL_UP_FL",				optionBOOL3, formatDIGIT, "lpm" },	// 23
	{ "SWR2_UNIT_WR",						optionBOOL3, formatDIGIT, "M"	},	// 24
	{ "SWR2_UNIT_EXH_DM",					optionBOOL3, formatDIGIT, "Pa"	},	// 25
	{ "SWR3_UNIT_DI_IN_SWR3_IN_FT_PG",		optionBOOL3, formatDIGIT, "Kpa"	},	// 26
	{ "SWR3_UNIT_CDA_IN_SWR4_MJ_PG",		optionBOOL3, formatDIGIT, "Kpa"	},	// 27
	{ "SWR3_UNIT_CDA_IN_SPARE_PORT_PG",		optionBOOL3, formatDIGIT, "Kpa"	},	// 28
	{ "SWR3_UNIT_CDA_IN_SWR4_MJ_IN_FT_PG",	optionBOOL3, formatDIGIT, "Kpa"	},	// 29
	{ "SWR3_UNIT_DI_SPL_LO_SWR3_FL",		optionBOOL3, formatDIGIT, "lpm"	},	// 30
	{ "SWR3_UNIT_DI_SPL_SWR3_IN_FT_FL",		optionBOOL3, formatDIGIT, "lpm"	},	// 31
	{ "SWR3_UNIT_DI_SPL_UP_SWR3_FL",		optionBOOL3, formatDIGIT, "lpm"	},	// 32
	{ "SWR3_UNIT_CDA_IN_SWR4_MJ_FL",		optionBOOL3, formatDIGIT, "lpm"	},	// 33
	{ "SWR3_UNIT_CDA_IN_SPARE_PORT_FL",		optionBOOL3, formatDIGIT, "lpm"	},	// 34
	{ "SWR3_UNIT_DI_SPL_WR",				optionBOOL3, formatDIGIT, "Moh"	},	// 35
	{ "SWR3_UNIT_EXH_DM",					optionBOOL3, formatDIGIT, "Pa"	},	// 36
	{ "SWR4_UNIT_LO_SWR_FL",				optionBOOL3, formatDIGIT, "lpm"	},	// 37
	{ "SWR4_UNIT_MJ_FL",					optionBOOL3, formatDIGIT, "lpm"	},	// 38
	{ "SWR4_UNIT_UP_SWR_FL",				optionBOOL3, formatDIGIT, "lpm"	},	// 39
	{ "SWR4_UNIT_AK_FL",					optionBOOL3, formatDIGIT, "lpm"	},	// 40
	{ "SWR4_UNIT_DI_SPL_FL",				optionBOOL3, formatDIGIT, "lpm"	},	// 41
	{ "SWR4_UNIT_EXH_DM",					optionBOOL3, formatDIGIT, "Pa"	},	// 42
	{ "SWR4_UNIT_DI_TANK2_CM",				optionBOOL3, formatDIGIT, "%"	},	// 43
	{ "AK_UNIT_DI_SPL_SWR4_IN_FT_PG",		optionBOOL3, formatDIGIT, "Kpa"	},	// 44
	{ "AK_UNIT_CDA_IN_LO_AK_IN_FT_PG",		optionBOOL3, formatDIGIT, "Kpa"	},	// 45
	{ "AK_UNIT_CDA_IN_UP_AK_IN_FT_PG",		optionBOOL3, formatDIGIT, "Kpa"	},	// 46
	{ "AK_UNIT_CDA_IN_LO_AK_PG",			optionBOOL3, formatDIGIT, "Kpa"	},	// 47
	{ "AK_UNIT_CDA_IN_UP_AK_PG",			optionBOOL3, formatDIGIT, "Kpa"	},	// 48
	{ "AK_UNIT_CDA_IN_ION_AND_AC_IN_FT_PG",	optionBOOL3, formatDIGIT, "Kpa"	},	// 49
	{ "AK_UNIT_CDA_IN_UP_SWR4_AC_PG",		optionBOOL3, formatDIGIT, "Kpa"	},	// 50
	{ "AK_UNIT_CDA_IN_LO_SWR4_AC_PG",		optionBOOL3, formatDIGIT, "Kpa"	},	// 51
	{ "AK_UNIT_CDA_IN_OUT_ION_PG",			optionBOOL3, formatDIGIT, "Kpa"	},	// 52
	{ "AK_UNIT_DRIVING_AIR_PG",				optionBOOL3, formatDIGIT, "Kpa"	},	// 53
	{ "AK_UNIT_EXH_DM_U",					optionBOOL3, formatDIGIT, "Pa"	},	// 54
	{ "AK_UNIT_EXH_DM_L",					optionBOOL3, formatDIGIT, "Pa"	},	// 55
	{ "AK_UNIT_DI_SPL_SHOWER4_IN_FT_FL",	optionBOOL3, formatDIGIT, "lpm"	},	// 56
	{ "AK_UNIT_CDA_IN_LO_AK_IN_FT_FL",		optionBOOL3, formatDIGIT, "lpm"	},	// 57
	{ "AK_UNIT_CDA_IN_UP_AK_IN_FT_FL",		optionBOOL3, formatDIGIT, "lpm"	},	// 58
	{ "AK_UNIT_DI_SPL_WR",					optionBOOL3, formatDIGIT, "Moh"	},	// 59
	{ "OUTCV_UNIT_ESD_SURIFACE_POTENTIAL",	optionBOOL3, formatDIGIT, "V"	},	// 60
#ifdef _MOTOR_LOAD_FACTOR
	{ "SWR2_RB_UP1_SERVO_LOAD_FATOR", 		optionBOOL3, formatDIGIT, "A"	},	// 61
	{ "SWR2_RB_LO1_SERVO_LOAD_FATOR", 		optionBOOL3, formatDIGIT, "A"	},	// 62
	{ "SWR2_RB_UP2_SERVO_LOAD_FATOR", 		optionBOOL3, formatDIGIT, "A"	},	// 63
	{ "SWR2_RB_LO2_SERVO_LOAD_FATOR", 		optionBOOL3, formatDIGIT, "A"	},	// 64
	{ "SWR3_RB_UP1_SERVO_LOAD_FATOR", 		optionBOOL3, formatDIGIT, "A"	},	// 65
	{ "SWR3_RB_LO1_SERVO_LOAD_FATOR", 		optionBOOL3, formatDIGIT, "A"	},	// 66
	{ "SWR3_RB_UP2_SERVO_LOAD_FATOR", 		optionBOOL3, formatDIGIT, "A"	},	// 67
	{ "SWR3_RB_LO2_SERVO_LOAD_FATOR", 		optionBOOL3, formatDIGIT, "A"	},	// 68
	{ "SWR2_RB_UP1_MOTOR_LOAD_FATOR",		optionBOOL3, formatDIGIT, "A"	},	// 69
	{ "SWR2_RB_LO1_MOTOR_LOAD_FATOR",		optionBOOL3, formatDIGIT, "A"	},	// 70
	{ "SWR2_RB_UP2_MOTOR_LOAD_FATOR",		optionBOOL3, formatDIGIT, "A"	},	// 71
	{ "SWR2_RB_LO2_MOTOR_LOAD_FATOR",		optionBOOL3, formatDIGIT, "A"	},	// 72
	{ "SWR3_RB_UP1_MOTOR_LOAD_FATOR",		optionBOOL3, formatDIGIT, "A"	},	// 73
	{ "SWR3_RB_LO1_MOTOR_LOAD_FATOR",		optionBOOL3, formatDIGIT, "A"	},	// 74
	{ "SWR3_RB_UP2_MOTOR_LOAD_FATOR",		optionBOOL3, formatDIGIT, "A"	},	// 75
	{ "SWR3_RB_LO2_MOTOR_LOAD_FATOR",		optionBOOL3, formatDIGIT, "A"	},	// 76
	{ "INCV_MOTOR_LOAD_FATOR",        		optionBOOL3, formatDIGIT, "A"	},	// 77
	{ "SWR1_CV_MOTOR_LOAD_FATOR",   		optionBOOL3, formatDIGIT, "A"	},	// 78
	{ "SWR2_CV_MOTOR1_LOAD_FATOR",   		optionBOOL3, formatDIGIT, "A"	},	// 79
	{ "SWR2_CV_MOTOR2_LOAD_FATOR",   		optionBOOL3, formatDIGIT, "A"	},	// 80
	{ "SWR3_CV_MOTOR1_LOAD_FATOR",   		optionBOOL3, formatDIGIT, "A"	},	// 81
	{ "SWR3_CV_MOTOR2_LOAD_FATOR",   		optionBOOL3, formatDIGIT, "A"	},	// 82
	{ "SWR4_CV_MOTOR_LOAD_FATOR",    		optionBOOL3, formatDIGIT, "A"	},	// 83
	{ "AK_CV_MOTOR1_LOAD_FATOR",    		optionBOOL3, formatDIGIT, "A"	},	// 84
	{ "AK_CV_MOTOR2_LOAD_FATOR",    		optionBOOL3, formatDIGIT, "A"	},	// 85
	{ "BUF_CV_MOTOR_LOAD_FATOR",     		optionBOOL3, formatDIGIT, "A"	},	// 86
	{ "OUTCV_MOTOR_LOAD_FATOR",      		optionBOOL3, formatDIGIT, "A"	},	// 87
#endif
};

SETUP_INFO CSetupItems::m_infoInterfacePara[] = 
{
	{ "MelsecNet Slot No",					optionNONE, formatDIGIT, "" },
	{ "Network Number",						optionNONE, formatDIGIT, "" },
	{ "Station Number",						optionNONE, formatDIGIT, "" },
	{ "T1 Timeout",							optionNONE, formatDIGIT, "Sec" },
	{ "T2 Timeout",							optionNONE, formatDIGIT, "Sec" },
	{ "T3 Timeout",							optionNONE, formatDIGIT, "Sec" },
	{ "T4 Timeout",							optionNONE, formatDIGIT, "Sec" },
	{ "T5 Timeout",							optionNONE, formatDIGIT, "Sec" },
};

SETUP_INFO CSetupItems::m_infoHsmsPara[] = 
{
	{ "Initial Comm. State",				optionBOOL6, formatSTRING, "" },
	{ "Initial Control State",				optionTRI_STATE2, formatSTRING, "" },
	{ "Establish Comm. Timeout",			optionNONE, formatDIGIT, "sec" },
	{ "Heart Beat",							optionNONE, formatDIGIT, "sec" },
	{ "T3 Replay Timeout",					optionNONE, formatDIGIT, "sec" },
	{ "T5 Separation Timeout",				optionNONE, formatDIGIT, "sec" },
	{ "T6 Transaction Timeout",				optionNONE, formatDIGIT, "sec" },
	{ "T7 NOT SELECTED Timeout",			optionNONE, formatDIGIT, "sec" },
	{ "T8 Network Inter-character Timeout",	optionNONE, formatDIGIT, "sec" },
	{ "T9 Conversation Timeout",			optionNONE, formatDIGIT, "sec" },
	{ "Link Test Timer (sec)",				optionNONE, formatDIGIT, "sec" },
	{ "Device ID",							optionNONE, formatDIGIT, "" },
	{ "Port Number (Remote)",				optionNONE, formatDIGIT, "" },
	{ "IP ADDRESS (Remote)",				optionNONE, formatFLOAT, "" },
	{ "Connection Mode",					optionBOOL5, formatSTRING, "" },
	{ "EQP ID",								optionNONE, formatSTRING, "" },
	{ "PROCESS ID",							optionNONE, formatSTRING, "" },
	{ "INDEX ID",							optionNONE, formatSTRING, "" },
};

// 240614 halesu
SETUP_INFO CSetupItems::m_infoPartsLifeTimePara[] = 
{
//#ifndef _NO_RB
	{ "SWR2 Unit R/B1 Up Brush",		optionNONE, formatDIGIT, "H" },
	{ "SWR2 Unit R/B1 Lo Brush",		optionNONE, formatDIGIT, "H" },
	{ "SWR2 Unit R/B2 Up Brush",		optionNONE, formatDIGIT, "H" },
	{ "SWR2 Unit R/B2 Lo Brush",		optionNONE, formatDIGIT, "H" },
	{ "SWR3 Unit R/B1 Up Brush",		optionNONE, formatDIGIT, "H" },
	{ "SWR3 Unit R/B1 Lo Brush",		optionNONE, formatDIGIT, "H" },
	{ "SWR3 Unit R/B2 Up Brush",		optionNONE, formatDIGIT, "H" },
	{ "SWR3 Unit R/B2 Lo Brush",		optionNONE, formatDIGIT, "H" },
//#endif
	{ "SWR1 SPL DI FILTER",			optionNONE, formatDIGIT, "H" },
	{ "SWR1 SPL FL DI FILTER",		optionNONE, formatDIGIT, "H" },
	{ "SWR2 DI FILTER",				optionNONE, formatDIGIT, "H" },
	{ "SWR3 DI FILTER",				optionNONE, formatDIGIT, "H" },
	{ "SWR4 SPL DI FILTER",			optionNONE, formatDIGIT, "H" },
	{ "SWR4 SPL FL DI FILTER",		optionNONE, formatDIGIT, "H" },
	{ "SWR1 ION AND AC CDA FILTER",	optionNONE, formatDIGIT, "H" },
	{ "SWR1 MJ CDA FILTER",			optionNONE, formatDIGIT, "H" },
	{ "SWR4 MJ CDA FILTER",			optionNONE, formatDIGIT, "H" },
	{ "AK AK LO CDA FILTER",		optionNONE, formatDIGIT, "H" },
	{ "AK AK UP CDA FILTER",		optionNONE, formatDIGIT, "H" },
	{ "AK ION AND AC CDA FILTER",	optionNONE, formatDIGIT, "H" },
};

SETUP_INFO CSetupItems::m_infoHsmsPara1[] = 
{
	{ "Initial Comm. State",				optionBOOL6, formatSTRING, "" },
	{ "Initial Control State",				optionTRI_STATE2, formatSTRING, "" },
	{ "Establish Comm. Timeout",			optionNONE, formatDIGIT, "sec" },
	{ "Heart Beat",							optionNONE, formatDIGIT, "sec" },
	{ "T3 Replay Timeout",					optionNONE, formatDIGIT, "sec" },
	{ "T5 Separation Timeout",				optionNONE, formatDIGIT, "sec" },
	{ "T6 Transaction Timeout",				optionNONE, formatDIGIT, "sec" },
	{ "T7 NOT SELECTED Timeout",			optionNONE, formatDIGIT, "sec" },
	{ "T8 Network Inter-character Timeout",	optionNONE, formatDIGIT, "sec" },
	{ "T9 Conversation Timeout",			optionNONE, formatDIGIT, "sec" },
	{ "Link Test Timer (sec)",				optionNONE, formatDIGIT, "sec" },
	{ "Device ID",							optionNONE, formatDIGIT, "" },
	{ "Port Number (Remote)",				optionNONE, formatDIGIT, "" },
	{ "IP ADDRESS (Remote)",				optionNONE, formatFLOAT, "" },
	{ "Connection Mode",					optionBOOL5, formatSTRING, "" },
	{ "EQP ID",								optionNONE, formatSTRING, "" },
	{ "PROCESS ID",							optionNONE, formatSTRING, "" },
	{ "INDEX ID",							optionNONE, formatSTRING, "" },
};

CString CSetupItems::m_sItemCvLength[] = 
{
	"INCV IN SENSOR - INCV OUT SENSOR",
	"INCV OUT SENSOR - SWR1 IN SENSOR",
	"SWR1 IN SENSOR - SWR1 OUT SENSOR",
	"SWR1 OUT SENSOR - SWR2 IN SENSOR",
	"SWR2 IN SENSOR - SWR2 OUT SENSOR",
	"SWR2 OUT SENSOR - SWR3 IN SENSOR",
	"SWR3 IN SENSOR - SWR3 OUT SENSOR",
	"SWR3 OUT SENSOR - SWR4 IN SENSOR",
	"SWR4 IN SENSOR - SWR4 OUT SENSOR",
	"SWR4 OUT SENSOR - AK IN SENSOR",
	"AK IN SENSOR - AK OUT SENSOR",
	"AK OUT SENSOR - BUF IN SENSOR",
	"BUF IN SENSOR - BUF OUT SENSOR",
	"BUF OUT SENSOR - OUTCV IN SENSOR",
	"OUTCV IN SENSOR - OUTCV OUT SENSOR",
	"OUTCV IN SENSOR - OUTCV ACC SENSOR",
	"OUTCV ACC SENSOR - OUTCV DEC SENSOR",
	"OUTCV DEC SENSOR - OUTCV OUT SENSOR",
};

CV_INFO CSetupItems::m_infoCvMotorPara[] =
{
	{ "INCV CV MOTOR",		formatDIGIT, formatDIGIT, formatDIGIT },
	{ "SWR1 CV MOTOR",		formatDIGIT, formatDIGIT, formatDIGIT },
	{ "SWR2 CV MOTOR",		formatDIGIT, formatDIGIT, formatDIGIT },
	{ "SWR3 CV MOTOR",		formatDIGIT, formatDIGIT, formatDIGIT },
	{ "SWR4 CV MOTOR",		formatDIGIT, formatDIGIT, formatDIGIT },
	{ "AK CV MOTOR",		formatDIGIT, formatDIGIT, formatDIGIT },
	{ "BUF CV MOTOR",		formatDIGIT, formatDIGIT, formatDIGIT },
	{ "OUTCV CV MOTOR1",	formatDIGIT, formatDIGIT, formatDIGIT },
};

CString CSetupItems::m_sItemDvName[] =	//  ϰ OCX Name ٷ  Ѵ.
{
	"GLS START TIME",
	"GLS END TIME",
	"SWR2 RB SHOW FLOW",
	"SWR2 RB A/C PRE",
	"SBJ DI FLOW",
	"SBJ1 CDA PRE",
	"SBJ2 CDA PRE",
	"AK UP CDA PRE",
	"AK LO CDA PRE",
	"AK UP CDA FLOW",
	"AK LO CDA FLOW",
	"AK UPPER EXT",
	"AK LOWER EXT",
	"DRV AIR PRE",
};
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSetupItems::CSetupItems()
{
	m_IniDualSensorSkip.Open("DualSensorSkip","SETUPINFO");	// SanghoCho 2015.04.30 FOR DUAL SENSOR
}

void CSetupItems::InitSetupItems()
{
	// Setup Info
	m_nItemNoSetup = sizeof( m_infoSetup ) / sizeof( SETUP_INFO );
	m_nValueSetup_Option = new int[m_nItemNoSetup];
	m_sValueSetup = new CString[m_nItemNoSetup];
	m_nValueSetup_OptionTemp = new int[m_nItemNoSetup];
	m_sValueSetupTemp = new CString[m_nItemNoSetup];

	// DI Tank Level
	m_nItemNoTankLevel = sizeof( m_sNameTankLevel ) / sizeof( CString );
	m_nValueTankLevel = new int[m_nItemNoTankLevel];
	m_nValueTankLevelTemp = new int[m_nItemNoTankLevel];

	// Idle Run Info
	m_nItemNoIdleRun = sizeof( m_infoIdleRun ) / sizeof( SETUP_INFO );
	m_nValueIdleRun = new int[m_nItemNoIdleRun];
	m_nValueIdleRunTemp = new int[m_nItemNoIdleRun];

	// InSensor Off TimeOut Interlock
	m_nItemNoInSensorTimeOut		= sizeof( m_sItemInSensorOffTimeOut ) / sizeof( CString );
	m_nValueInSensorOffTimeOut		= new int[m_nItemNoInSensorTimeOut];
	m_nValueInSensorOffTimeOutTemp	= new int[m_nItemNoInSensorTimeOut];

	// OutSensor Off TimeOut Interlock
	m_nItemNoOutSensorTimeOut		= sizeof( m_sItemOutSensorOffTimeOut ) / sizeof( CString );
	m_nValueOutSensorOffTimeOut		= new int[m_nItemNoOutSensorTimeOut];
	m_nValueOutSensorOffTimeOutTemp	= new int[m_nItemNoOutSensorTimeOut];

	// Gauge Limit
	m_nItemNoGaugeLimit = m_pEqpAssy->m_AnalogInput.GetAiSize(); // sizeof( m_infoGaugeLimit ) / sizeof( SETUP_INFO );

	// i = 0 : // MIN
	// i = 1 : // Warning MIN
	// i = 2 : // Warning MAX
	// i = 3 : // MAX
	for( int i=0; i<4; i++ ) 
	{
		m_nValueGaugeLimit[i]		= new int[m_nItemNoGaugeLimit];
		m_nValueGaugeLimitTemp[i]	= new int[m_nItemNoGaugeLimit];
	}
	m_nValueGaugeLimit_Option		= new int[m_nItemNoGaugeLimit];
	m_nValueGaugeLimit_OptionTemp	= new int[m_nItemNoGaugeLimit];

	// Sensor Interlock
	m_nItemNoBathCoverIntr    = sizeof( m_sItemBathCoverIntr ) / sizeof( CString );
	m_nValueBathCoverIntr	   = new int[m_nItemNoBathCoverIntr];
	m_nValueBathCoverIntrTemp = new int[m_nItemNoBathCoverIntr];

	m_nItemNoDoorIntr    = sizeof( m_sItemDoorIntr ) / sizeof( CString );
	m_nValueDoorIntr	   = new int[m_nItemNoDoorIntr];
	m_nValueDoorIntrTemp = new int[m_nItemNoDoorIntr];

	m_nItemNoLeakDetectIntr    = sizeof( m_sItemLeakDetectIntr ) / sizeof( CString );
	m_nValueLeakDetectIntr	   = new int[m_nItemNoLeakDetectIntr];
	m_nValueLeakDetectIntrTemp = new int[m_nItemNoLeakDetectIntr];

	m_nItemNoFFUAlarmIntr    = sizeof( m_sItemFFUAlarmIntr ) / sizeof( CString );
	m_nValueFFUAlarmIntr	   = new int[m_nItemNoFFUAlarmIntr];
	m_nValueFFUAlarmIntrTemp = new int[m_nItemNoFFUAlarmIntr];

	m_nItemNoBrokenIntr    = sizeof( m_sItemBrokenIntr ) / sizeof( CString );
	m_nValueBrokenIntr	   = new int[m_nItemNoBrokenIntr];
	m_nValueBrokenIntrTemp = new int[m_nItemNoBrokenIntr];

	m_nItemNoETCIntr    = sizeof( m_sItemETCIntr ) / sizeof( CString );
	m_nValueETCIntr	   = new int[m_nItemNoETCIntr];
	m_nValueETCIntrTemp = new int[m_nItemNoETCIntr];

	// HSMS Parameter
	m_nItemNoHsmsPara		= sizeof( m_infoHsmsPara ) / sizeof( SETUP_INFO );
	m_sValueHsmsPara		= new CString[m_nItemNoHsmsPara];
	m_sValueHsmsParaTemp	= new CString[m_nItemNoHsmsPara];

	// HSMS1 Parameter
	m_nItemNoHsmsPara1		= sizeof( m_infoHsmsPara1 ) / sizeof( SETUP_INFO );
	m_sValueHsmsPara1		= new CString[m_nItemNoHsmsPara1];
	m_sValueHsmsParaTemp1	= new CString[m_nItemNoHsmsPara1];

	// Interface Parameter
	m_nItemNoInterfacePara		= sizeof( m_infoInterfacePara ) / sizeof( SETUP_INFO );
	m_sValueInterfacePara		= new CString[m_nItemNoInterfacePara];
	m_sValueInterfaceParaTemp	= new CString[m_nItemNoInterfacePara];

	// Parts LifeTime Parameter
	m_nItemNoPartsLifeTimePara		= sizeof( m_infoPartsLifeTimePara ) / sizeof( SETUP_INFO );
	for( int i = 0; i < 2; i++ )
	{
		m_nValuePartsLifeTimePara[i]		= new int[m_nItemNoPartsLifeTimePara];
		m_nValuePartsLifeTimeParaTemp[i] 	= new int[m_nItemNoPartsLifeTimePara];
	}

	// CV Length
	m_nItemNoCvLength		= sizeof( m_sItemCvLength ) / sizeof( CString );
	m_fValueCvLength		= new double[m_nItemNoCvLength];
	m_fValueCvLengthTemp	= new double[m_nItemNoCvLength];

	// CV Motor Parameter
	m_nItemNoCvMotorPara		= sizeof( m_infoCvMotorPara ) / sizeof( CV_INFO );	// ljy_050401 : change CString->CV_INFO
	m_fValueCvMotorRatio		= new double[m_nItemNoCvMotorPara];
	m_fValueCvMotorRatioTemp	= new double[m_nItemNoCvMotorPara];
	m_fValueCvMotorDia				= new double[m_nItemNoCvMotorPara];
	m_fValueCvMotorDiaTemp			= new double[m_nItemNoCvMotorPara];
	m_fValueCvMotorVelRatio			= new double[m_nItemNoCvMotorPara];
	m_fValueCvMotorVelRatioTemp		= new double[m_nItemNoCvMotorPara];

	m_nItemNoDvName			= sizeof( m_sItemDvName ) / sizeof( CString );
	m_sValueDvName			= new CString[m_nItemNoDvName];
	m_sValueDvNameTemp		= new CString[m_nItemNoDvName];

	// Clear the flag
	m_bCalReq	= FALSE;
	m_bCalCancel = FALSE;

	m_nUnitInSensorSkip			= sizeof( m_sItemInSensorSkip ) / sizeof( CString );
	m_nValueInSensorSkipTemp	= new int[m_nUnitInSensorSkip];
	m_nUnitOutSensorSkip		= sizeof( m_sItemOutSensorSkip ) / sizeof( CString );
	m_nValueOutSensorSkipTemp	= new int[m_nUnitOutSensorSkip];
	
	m_nUnitSubInSensorSkip			= sizeof( m_sItemSubInSensorSkip ) / sizeof( CString );
	m_nValueSubInSensorSkipTemp	= new int[m_nUnitSubInSensorSkip];
	m_nUnitSubOutSensorSkip		= sizeof( m_sItemSubOutSensorSkip ) / sizeof( CString );
	m_nValueSubOutSensorSkipTemp	= new int[m_nUnitSubOutSensorSkip];
}

CSetupItems::~CSetupItems()
{
	delete []m_nValueSetup_Option;
	delete []m_sValueSetup;
	delete []m_nValueSetup_OptionTemp;
	delete []m_sValueSetupTemp;

	delete []m_nValueIdleRun;
	delete []m_nValueIdleRunTemp;

	delete []m_nValueTankLevel;
	delete []m_nValueTankLevelTemp;

	delete []m_nValueInSensorOffTimeOut;
	delete []m_nValueInSensorOffTimeOutTemp;
	delete []m_nValueOutSensorOffTimeOut;
	delete []m_nValueOutSensorOffTimeOutTemp;

	for( int i=0; i<4; i++ ) 
	{
		delete []m_nValueGaugeLimit[i];
		delete []m_nValueGaugeLimitTemp[i];
	}
	delete []m_nValueGaugeLimit_Option;
	delete []m_nValueGaugeLimit_OptionTemp;

	delete []m_nValueBathCoverIntr;
	delete []m_nValueBathCoverIntrTemp;
	delete []m_nValueDoorIntr;
	delete []m_nValueDoorIntrTemp;
	delete []m_nValueLeakDetectIntr;
	delete []m_nValueLeakDetectIntrTemp;
	delete []m_nValueFFUAlarmIntr;
	delete []m_nValueFFUAlarmIntrTemp;
	delete []m_nValueBrokenIntr;
	delete []m_nValueBrokenIntrTemp;
	delete []m_nValueETCIntr;
	delete []m_nValueETCIntrTemp;

	delete []m_sValueHsmsPara;
	delete []m_sValueHsmsParaTemp;
	delete []m_sValueInterfacePara;
	delete []m_sValueInterfaceParaTemp;

	delete []m_sValueHsmsPara1;
	delete []m_sValueHsmsParaTemp1;

	for( int i=0; i<2; i++ ) 
	{
		delete []m_nValuePartsLifeTimePara[i];
		delete []m_nValuePartsLifeTimeParaTemp[i];
	}

	delete []m_fValueCvLength;
	delete []m_fValueCvLengthTemp;

	delete [] m_fValueCvMotorRatio;
	delete [] m_fValueCvMotorRatioTemp;
	delete [] m_fValueCvMotorDia;
	delete [] m_fValueCvMotorDiaTemp;
	delete [] m_fValueCvMotorVelRatio;
	delete [] m_fValueCvMotorVelRatioTemp;

	delete []m_sValueDvName;
	delete []m_sValueDvNameTemp;

	delete [] m_nValueInSensorSkipTemp;
	delete [] m_nValueOutSensorSkipTemp;
	
	delete [] m_nValueSubInSensorSkipTemp;
	delete [] m_nValueSubOutSensorSkipTemp;
}

//--------------------------------------------------------------------
// InitTempVarTab1()
//--------------------------------------------------------------------
void CSetupItems::InitTempVarTabJobCondView()
{
	int i;
	for( i=0; i<m_nItemNoSetup; i++ ) 
	{
		m_nValueSetup_OptionTemp[i] = m_nValueSetup_Option[i];
		m_sValueSetupTemp[i] = m_sValueSetup[i];
	}
	for( i=0; i<m_nItemNoIdleRun; i++ ) m_nValueIdleRunTemp[i] = m_nValueIdleRun[i];
	for( i=0; i<m_nItemNoTankLevel; i++ ) m_nValueTankLevelTemp[i] = m_nValueTankLevel[i];

	for( i=0; i<m_nItemNoPartsLifeTimePara; i++ )
	{
		m_nValuePartsLifeTimeParaTemp[0][i] = m_nValuePartsLifeTimePara[0][i];
		m_nValuePartsLifeTimeParaTemp[1][i] = m_nValuePartsLifeTimePara[1][i];
	}
}

//--------------------------------------------------------------------
// InitTempVarTab2()
//--------------------------------------------------------------------
void CSetupItems::InitTempVarTabInterlockSetView()
{

	for( int i=0; i<m_nItemNoGaugeLimit; i++ ) 
	{
		m_nValueGaugeLimitTemp[0][i] = m_nValueGaugeLimit[0][i];
		m_nValueGaugeLimitTemp[1][i] = m_nValueGaugeLimit[1][i];
		m_nValueGaugeLimitTemp[2][i] = m_nValueGaugeLimit[2][i];
		m_nValueGaugeLimitTemp[3][i] = m_nValueGaugeLimit[3][i];
		
		m_nValueGaugeLimit_OptionTemp[i] = m_nValueGaugeLimit_Option[i];
	}
}

//--------------------------------------------------------------------
// InitTempVarTab2()
//--------------------------------------------------------------------
void CSetupItems::InitTempVarTabInterlockSet2View()
{
	int i;
	for( i=0; i<m_nItemNoBathCoverIntr; i++ )
	{
		m_nValueBathCoverIntrTemp[i] = m_nValueBathCoverIntr[i];
	}
	for( i=0; i<m_nItemNoDoorIntr; i++ )
	{
		m_nValueDoorIntrTemp[i] = m_nValueDoorIntr[i];
	}
	for( i=0; i<m_nItemNoLeakDetectIntr; i++ )
	{
		m_nValueLeakDetectIntrTemp[i] = m_nValueLeakDetectIntr[i];
	}
	for( i=0; i<m_nItemNoFFUAlarmIntr; i++ )
	{
		m_nValueFFUAlarmIntrTemp[i] = m_nValueFFUAlarmIntr[i];
	}
	for( i=0; i<m_nItemNoBrokenIntr; i++ )
	{
		m_nValueBrokenIntrTemp[i] = m_nValueBrokenIntr[i];
	}
	for( i=0; i<m_nItemNoETCIntr; i++ )
	{
		m_nValueETCIntrTemp[i] = m_nValueETCIntr[i];
	}
}

//--------------------------------------------------------------------
// InitTempVarTab3()
//--------------------------------------------------------------------
void CSetupItems::InitTempVarTabInterfaceParaView()
{
	int i;
	for( i=0; i<m_nItemNoHsmsPara; i++ ) m_sValueHsmsParaTemp[i] = m_sValueHsmsPara[i];
	for( i=0; i<m_nItemNoInterfacePara; i++ ) m_sValueInterfaceParaTemp[i] = m_sValueInterfacePara[i];
}

//--------------------------------------------------------------------
// InitTempVarTab3()
//--------------------------------------------------------------------
void CSetupItems::InitTempVarTabInterfaceParaView1()
{
	for( int i=0; i<m_nItemNoHsmsPara1; i++ )
	{
		m_sValueHsmsParaTemp1[i] = m_sValueHsmsPara1[i];
	}
}

//--------------------------------------------------------------------
// InitTempVarTab4()
//--------------------------------------------------------------------
void CSetupItems::InitTempVarTabCVDistanceSetView()
{
	int i;
	for( i=0; i<m_nItemNoCvLength; i++ ) m_fValueCvLengthTemp[i] = m_fValueCvLength[i];
	for( i=0; i<m_nItemNoInSensorTimeOut; i++ ) m_nValueInSensorOffTimeOutTemp[i] = m_nValueInSensorOffTimeOut[i];
	for( i=0; i<m_nItemNoOutSensorTimeOut; i++ ) m_nValueOutSensorOffTimeOutTemp[i] = m_nValueOutSensorOffTimeOut[i];
}

//--------------------------------------------------------------------
// InitTempVarTab5()
//--------------------------------------------------------------------
void CSetupItems::InitTempVarTabCVMotorParaView()
{
	for( int i=0; i<m_nItemNoCvMotorPara; i++ )
	{
		m_fValueCvMotorRatioTemp[i]		= m_fValueCvMotorRatio[i];
		m_fValueCvMotorDiaTemp[i]		= m_fValueCvMotorDia[i];
		m_fValueCvMotorVelRatioTemp[i]	= m_fValueCvMotorVelRatio[i];
	}
}

//--------------------------------------------------------------------
// InitTempVarTab6()
//--------------------------------------------------------------------
void CSetupItems::InitTempVarTabDVParaView()
{
	for( int i=0; i<m_nItemNoDvName; i++ ) m_sValueDvNameTemp[i] = m_sValueDvName[i];
}

//--------------------------------------------------------------------
// IsSetupChangedTab1()
//--------------------------------------------------------------------
BOOL CSetupItems::IsSetupChangedTabJobCondView()
{
	int i;
	for( i=0; i<m_nItemNoSetup; i++ )
	{
		if( m_nValueSetup_OptionTemp[i] != m_nValueSetup_Option[i] ) return TRUE;
		if( m_sValueSetupTemp[i] != m_sValueSetup[i] ) return TRUE;
	}

	for( i=0; i<m_nItemNoIdleRun; i++ )
	{
		if( m_nValueIdleRunTemp[i] != m_nValueIdleRun[i] ) return TRUE;
	}

	for( i=0; i<m_nItemNoTankLevel; i++ )
	{
		if( m_nValueTankLevelTemp[i] != m_nValueTankLevel[i] ) return TRUE;
	}

	for( i=0; i<m_nItemNoPartsLifeTimePara; i++ )
	{
		if( m_nValuePartsLifeTimeParaTemp[0][i] != m_nValuePartsLifeTimePara[0][i] ) return TRUE;
		if( m_nValuePartsLifeTimeParaTemp[1][i] != m_nValuePartsLifeTimePara[1][i] ) return TRUE;
	}

	return FALSE;
}

//--------------------------------------------------------------------
// IsSetupChangedTab2()
//--------------------------------------------------------------------
BOOL CSetupItems::IsSetupChangedTabInterlockSetView()
{

	for( int i=0; i<m_nItemNoGaugeLimit; i++ )
	{
		for( int j=0; j<4; j++ )
		{
			if( m_nValueGaugeLimitTemp[j][i] != m_nValueGaugeLimit[j][i] ) return TRUE;
		}
		if( m_nValueGaugeLimit_OptionTemp[i] != m_nValueGaugeLimit_Option[i] ) return TRUE;
	}

	return FALSE;
}

//--------------------------------------------------------------------
// IsSetupChangedTab2()
//--------------------------------------------------------------------
BOOL CSetupItems::IsSetupChangedTabInterlockSet2View()
{
	int i;
	for( i=0; i<m_nItemNoBathCoverIntr; i++ )
	{
		if( m_nValueBathCoverIntrTemp[i] != m_nValueBathCoverIntr[i] ) return TRUE;
	}
	for( i=0; i<m_nItemNoDoorIntr; i++ )
	{
		if( m_nValueDoorIntrTemp[i] != m_nValueDoorIntr[i] ) return TRUE;
	}
	for( i=0; i<m_nItemNoLeakDetectIntr; i++ )
	{
		if( m_nValueLeakDetectIntrTemp[i] != m_nValueLeakDetectIntr[i] ) return TRUE;
	}
	for( i=0; i<m_nItemNoFFUAlarmIntr; i++ )
	{
		if( m_nValueFFUAlarmIntrTemp[i] != m_nValueFFUAlarmIntr[i] ) return TRUE;
	}
	for( i=0; i<m_nItemNoBrokenIntr; i++ )
	{
		if( m_nValueBrokenIntrTemp[i] != m_nValueBrokenIntr[i] ) return TRUE;
	}
	for( i=0; i<m_nItemNoETCIntr; i++ )
	{
		if( m_nValueETCIntrTemp[i] != m_nValueETCIntr[i] ) return TRUE;
	}

	return FALSE;
}


//--------------------------------------------------------------------
// IsSetupChangedTab3()
//--------------------------------------------------------------------
BOOL CSetupItems::IsSetupChangedTabCVDistanceSetView()
{
	int i;
	for( i=0; i<m_nItemNoCvLength; i++ )
	{
		if( m_fValueCvLengthTemp[i] != m_fValueCvLength[i] ) return TRUE;
	}

	for( i=0; i<m_nItemNoInSensorTimeOut; i++ )
	{
		if( m_nValueInSensorOffTimeOutTemp[i] != m_nValueInSensorOffTimeOut[i] ) return TRUE;
	}

	for( i=0; i<m_nItemNoOutSensorTimeOut; i++ )
	{
		if( m_nValueOutSensorOffTimeOutTemp[i] != m_nValueOutSensorOffTimeOut[i] ) return TRUE;
	}

	return FALSE;
}

BOOL CSetupItems::IsSetupChangedTabInterfaceParaView()
{
	int i;
	for( i=0; i<m_nItemNoHsmsPara; i++ )
	{
		if( m_sValueHsmsParaTemp[i] != m_sValueHsmsPara[i] ) return TRUE;
	}
	for( i=0; i<m_nItemNoInterfacePara; i++ )
	{
		if( m_sValueInterfaceParaTemp[i] != m_sValueInterfacePara[i] ) return TRUE;
	}

	return FALSE;
}

BOOL CSetupItems::IsSetupChangedTabInterfaceParaView1()
{
	for( int i=0; i<m_nItemNoHsmsPara1; i++ )
	{
		if( m_sValueHsmsParaTemp1[i] != m_sValueHsmsPara1[i] ) return TRUE;
	}
	return FALSE;
}
//--------------------------------------------------------------------
// IsSetupChangedTab4()
//--------------------------------------------------------------------
BOOL CSetupItems::IsSetupChangedTabCVMotorParaView()
{
	for( int i=0; i<m_nItemNoCvMotorPara; i++ )
	{
		if( m_fValueCvMotorRatioTemp[i] != m_fValueCvMotorRatio[i] ) return TRUE;
		if( m_fValueCvMotorDiaTemp[i] != m_fValueCvMotorDia[i] ) return TRUE;
		if( m_fValueCvMotorVelRatioTemp[i] != m_fValueCvMotorVelRatio[i] ) return TRUE;
	}

	return FALSE;
}

//--------------------------------------------------------------------
// IsSetupChangedTab5()
//--------------------------------------------------------------------
BOOL CSetupItems::IsSetupChangedTabDVParaView()
{
	for( int i=0; i<m_nItemNoDvName; i++ )
	{
		if( m_sValueDvNameTemp[i] != m_sValueDvName[i] ) return TRUE;
	}

	return FALSE;
}

//--------------------------------------------------------------------
// GetRegistryTab1()
//--------------------------------------------------------------------
void CSetupItems::GetRegistryTabJobCondView()
{
	int i;
	m_IniSetUpInfo.Open("JobCon","SETUPINFO");

	for( i=0; i<m_nItemNoSetup; i++ )
	{
		CString sBuf;
		m_nValueSetup_Option[i] = m_IniSetUpInfo.GetIntValue( "JOB CONDITION OPTION", m_infoSetup[i].sName, 0 );
		m_nValueSetup_OptionTemp[i] = m_nValueSetup_Option[i];
		m_sValueSetup[i] = m_IniSetUpInfo.GetStringValue( "JOB CONDITION VALUE", m_infoSetup[i].sName, "10" );
		m_sValueSetupTemp[i] = m_sValueSetup[i];
	}

	for( i=0; i<m_nItemNoIdleRun; i++ )
	{
		m_nValueIdleRun[i] = m_IniSetUpInfo.GetIntValue( "IDLE CONDITION", m_infoIdleRun[i].sName, 0 );
		m_nValueIdleRunTemp[i] = m_nValueIdleRun[i];
	}

	for( i=0; i<m_nItemNoTankLevel; i++ )
	{
		m_nValueTankLevel[i] = m_IniSetUpInfo.GetIntValue( "TANK LEVEL SET", m_sNameTankLevel[i], 0 );
		m_nValueTankLevelTemp[i] = m_nValueTankLevel[i];
	}

	for( i=0; i<m_nItemNoPartsLifeTimePara; i++ )
	{
		m_nValuePartsLifeTimePara[0][i] = 
			m_IniSetUpInfo.GetIntValue( "PARTS LIFE TIME (GLASS COUNT)", m_infoPartsLifeTimePara[i].sName, 10 );
		m_nValuePartsLifeTimeParaTemp[0][i] = m_nValuePartsLifeTimePara[0][i];
		
		m_nValuePartsLifeTimePara[1][i] = 
			m_IniSetUpInfo.GetIntValue( "PARTS LIFE TIME (RUN TIME)", m_infoPartsLifeTimePara[i].sName, 10 );
		m_nValuePartsLifeTimeParaTemp[1][i] = m_nValuePartsLifeTimePara[1][i];
	}
}

void CSetupItems::GetRegistryTabDualSensorSkip()
{
	int i;
	m_IniSetUpInfo.Open("DualSensorSkip","SETUPINFO");

	for( i=0; i<MAX_UNIT_NO; i++ )
	{
		m_nValueInSensorSkipTemp[i] = m_IniDualSensorSkip.GetIntValue("DICS SET TAB JOB COND",m_sItemInSensorSkip[i], 0 );
		m_nValueOutSensorSkipTemp[i]= m_IniDualSensorSkip.GetIntValue("DICS SET TAB JOB COND",m_sItemOutSensorSkip[i], 0 );
		
		m_nValueSubInSensorSkipTemp[i] = m_IniDualSensorSkip.GetIntValue("DICS SET TAB JOB COND",m_sItemSubInSensorSkip[i], 0 );
		m_nValueSubOutSensorSkipTemp[i]= m_IniDualSensorSkip.GetIntValue("DICS SET TAB JOB COND",m_sItemSubOutSensorSkip[i], 0 );
	}
}

//--------------------------------------------------------------------
// GetRegistrySensorIntr()
// m_nValueGaugeLimit[i][j]
//	i : 0 ~ 4 : MIN, W_MIN, W_MAX, MAX
//	j : 0 ~ m_nItemNoGaugeLimit
//--------------------------------------------------------------------
void CSetupItems::GetRegistryTabInterlockSetView()
{
	for( int i=0; i<m_pEqpAssy->m_AnalogInput.GetAiSize(); i++ )
	{
		int nReal = m_pEqpAssy->m_AnalogInput.GetAddress( i );
		int nIntrNo = m_pEqpAssy->m_AnalogInput.m_aiSet[i].nAiIntrNo;
		if( nIntrNo < 0 ) continue;
		m_pDevice->GetInterlockPara( nReal, m_nValueGaugeLimit_Option[nIntrNo], 
			m_nValueGaugeLimit[3][nIntrNo], m_nValueGaugeLimit[0][nIntrNo] );
		m_pDevice->GetWarningPara( nReal, m_nValueGaugeLimit_Option[nIntrNo],
			m_nValueGaugeLimit[2][nIntrNo], m_nValueGaugeLimit[1][nIntrNo] );

		m_nValueGaugeLimit_OptionTemp[nIntrNo] = m_nValueGaugeLimit_Option[nIntrNo];
		for( int j=0; j<4; j++ )
		{
			m_nValueGaugeLimitTemp[j][nIntrNo] = m_nValueGaugeLimit[j][nIntrNo];
		}
	}
}

//--------------------------------------------------------------------
// GetRegistrySensorIntr()
// m_nValueGaugeLimit[i][j]
//	i : 0 ~ 4 : MIN, W_MIN, W_MAX, MAX
//	j : 0 ~ m_nItemNoGaugeLimit
//--------------------------------------------------------------------
void CSetupItems::GetRegistryTabInterlockSet2View()
{
	int i;
	m_IniSetUpInfo.Open("EqpInterlock2","SETUPINFO");

	for( i=0; i<m_nItemNoDoorIntr; i++ )
	{
		m_nValueDoorIntr[i] = m_IniSetUpInfo.GetIntValue( "INTERLOCK SET : DOOR OPEN", m_sItemDoorIntr[i], 0 );
		m_nValueDoorIntrTemp[i] = m_nValueDoorIntr[i];
	}
	for( i=0; i<m_nItemNoBathCoverIntr; i++ )
	{
		m_nValueBathCoverIntr[i] = m_IniSetUpInfo.GetIntValue( "INTERLOCK SET : BATH COVER", m_sItemBathCoverIntr[i], 0 );
		m_nValueBathCoverIntrTemp[i] = m_nValueBathCoverIntr[i];
	}
	for( i=0; i<m_nItemNoLeakDetectIntr; i++ )
	{
		m_nValueLeakDetectIntr[i] = m_IniSetUpInfo.GetIntValue( "INTERLOCK SET : LEAK", m_sItemLeakDetectIntr[i], 0 );
		m_nValueLeakDetectIntrTemp[i] = m_nValueLeakDetectIntr[i];
	}
	for( i=0; i<m_nItemNoFFUAlarmIntr; i++ )
	{
		m_nValueFFUAlarmIntr[i] = m_IniSetUpInfo.GetIntValue( "INTERLOCK SET : FFU", m_sItemFFUAlarmIntr[i], 0 );
		m_nValueFFUAlarmIntrTemp[i] = m_nValueFFUAlarmIntr[i];
	}
/*
	for( i=0; i<m_nItemNoBrokenIntr; i++ )
	{
		m_nValueBrokenIntr[i] = m_IniSetUpInfo.GetIntValue( "INTERLOCK SET(BROKEN)", m_sItemBrokenIntr[i], 0 );
		m_nValueBrokenIntrTemp[i] = m_nValueBrokenIntr[i];
	}
*/
	for( i=0; i<m_nItemNoETCIntr; i++ )
	{
		m_nValueETCIntr[i] = m_IniSetUpInfo.GetIntValue( "INTERLOCK SET : ETC", m_sItemETCIntr[i], 0 );
		m_nValueETCIntrTemp[i] = m_nValueETCIntr[i];
	}
}

//--------------------------------------------------------------------
// GetRegistryTab4()
//--------------------------------------------------------------------
void CSetupItems::GetRegistryTabInterfaceParaView()
{
	int i;
	m_IniSetUpInfo.Open("Interface","SETUPINFO");

	for( i=0; i<m_nItemNoHsmsPara; i++ )
	{
		m_sValueHsmsPara[i] = m_IniSetUpInfo.GetStringValue( "HSMS PARAMETER", m_infoHsmsPara[i].sName, "10" );
		m_sValueHsmsParaTemp[i] = m_sValueHsmsPara[i];
	}

	for( i=0; i<m_nItemNoInterfacePara; i++ )
	{
		m_sValueInterfacePara[i] = m_IniSetUpInfo.GetStringValue( "IF PARAMETER", m_infoInterfacePara[i].sName, "10" );
		m_sValueInterfaceParaTemp[i] = m_sValueInterfacePara[i];
	}
}

//--------------------------------------------------------------------
void CSetupItems::GetRegistryTabInterfaceParaView1()
{
	m_IniSetUpInfo.Open("Interface1","SETUPINFO");

	for( int i=0; i<m_nItemNoHsmsPara1; i++ )
	{
		m_sValueHsmsPara1[i] = m_IniSetUpInfo.GetStringValue( "HSMS PARAMETER(2)", m_infoHsmsPara1[i].sName, "10" );
		m_sValueHsmsParaTemp1[i] = m_sValueHsmsPara1[i];
	}
}
// GetRegistryTab5()
//--------------------------------------------------------------------
void CSetupItems::GetRegistryTabCVDistanceSetView()
{
	m_IniSetUpInfo.Open("CvDistancePara","SETUPINFO");

	int i;	
	for( i=0; i<m_nItemNoCvLength; i++ )
	{
		CString sBuf = m_IniSetUpInfo.GetStringValue( "CV DISTANCE", (LPCTSTR)m_sItemCvLength[i], "100" );
		m_fValueCvLength[i] = atof( sBuf );
		m_fValueCvLengthTemp[i] = m_fValueCvLength[i];
	}
	
	for( i=0; i<m_nItemNoInSensorTimeOut; i++ )
	{
		m_nValueInSensorOffTimeOut[i] = m_IniSetUpInfo.GetIntValue( "IN SENSOR OFF TIMEOUT", (LPCTSTR)m_sItemInSensorOffTimeOut[i], 0 );
		m_nValueInSensorOffTimeOutTemp[i] = m_nValueInSensorOffTimeOut[i];
	}

	for( i=0; i<m_nItemNoOutSensorTimeOut; i++ )
	{
		m_nValueOutSensorOffTimeOut[i] = m_IniSetUpInfo.GetIntValue( "OUT SENSOR OFF TIMEOUT", (LPCTSTR)m_sItemOutSensorOffTimeOut[i], 0 );
		m_nValueOutSensorOffTimeOutTemp[i] = m_nValueOutSensorOffTimeOut[i];
	}
}

//--------------------------------------------------------------------
// GetRegistryTab6()
//--------------------------------------------------------------------
void CSetupItems::GetRegistryTabCVMotorParaView() // minhanx 080922 ̰Ŵ ̻..eqpassy cvmotor setting.
{
/*	CDicsApp* pApp = (CDicsApp*) AfxGetApp();

	CString sBuf;
	for( int i=0; i<m_nItemNoCvMotorPara; i++ )
	{
		CString sBuf;
		sBuf = m_IniSetUpInfo.GetStringValue( "C/V MOTOR RATIO", m_infoCvMotorPara[i].sName, "10" );
		m_fValueCvMotorRatio[i] = atof( sBuf );
		m_fValueCvMotorRatioTemp[i] = m_fValueCvMotorRatio[i];

		sBuf = m_IniSetUpInfo.GetStringValue( "C/V MOTOR DIAMETER", m_infoCvMotorPara[i].sName, "60" );
		m_fValueCvMotorDia[i] = atof( sBuf );
		m_fValueCvMotorDiaTemp[i] = m_fValueCvMotorDia[i];

		sBuf = m_IniSetUpInfo.GetStringValue( "C/V MOTOR VELOCITY", m_infoCvMotorPara[i].sName, "1" );
		m_fValueCvMotorVelRatio[i] = atof( sBuf );
		m_fValueCvMotorVelRatioTemp[i] = m_fValueCvMotorVelRatio[i];
	}
*/
}

//--------------------------------------------------------------------
// GetRegistryTab7()
//--------------------------------------------------------------------
void CSetupItems::GetRegistryTabDVParaView()
{
	m_IniSetUpInfo.Open("DV PARA","SETUPINFO");

	for( int i=0; i<m_nItemNoDvName; i++ )
	{
		m_sValueDvName[i] = m_IniSetUpInfo.GetStringValue( "D/V PARAMETER", m_sItemDvName[i], "" );
		m_sValueDvNameTemp[i] = m_sValueDvName[i];
	}
}

//--------------------------------------------------------------------
// SetRegistrySensorIntr()
//--------------------------------------------------------------------
void CSetupItems::SetRegistryTabJobCondView()
{
	int i;
	m_IniSetUpInfo.Open("JobCon","SETUPINFO");

	for( i=0; i<m_nItemNoSetup; i++ )
	{
		m_nValueSetup_Option[i] = m_nValueSetup_OptionTemp[i];
		m_sValueSetup[i] = m_sValueSetupTemp[i];

		if ( m_infoSetup[i].nOption == optionNONE )
		{
			m_IniSetUpInfo.SetStringValue( "JOB CONDITION VALUE", m_infoSetup[i].sName, m_sValueSetup[i], TRUE );
		}
		else if( m_infoSetup[i].nOption == optionBOOL6 )	// 150915 halesu
		{
			m_IniSetUpInfo.SetIntValue( "JOB CONDITION OPTION", m_infoSetup[i].sName, m_nValueSetup_Option[i], TRUE );	
			m_IniSetUpInfo.SetStringValue( "JOB CONDITION VALUE", m_infoSetup[i].sName, m_sValueSetup[i], TRUE );
		}
		else
		{
			m_IniSetUpInfo.SetIntValue( "JOB CONDITION OPTION", m_infoSetup[i].sName, m_nValueSetup_Option[i], TRUE );	
		}
	}

	for( i=0; i<m_nItemNoIdleRun; i++ )
	{
		m_nValueIdleRun[i] = m_nValueIdleRunTemp[i];
		m_IniSetUpInfo.SetIntValue( "IDLE CONDITION", m_infoIdleRun[i].sName, m_nValueIdleRun[i], TRUE );
	}

		for( i=0; i<m_nItemNoTankLevel; i++ )
	{
		m_nValueTankLevel[i] = m_nValueTankLevelTemp[i];
		m_IniSetUpInfo.SetIntValue( "TANK LEVEL SET", m_sNameTankLevel[i], m_nValueTankLevel[i], TRUE );
	}

	for( i=0; i<m_nItemNoPartsLifeTimePara; i++ )
	{
		m_nValuePartsLifeTimePara[0][i] = m_nValuePartsLifeTimeParaTemp[0][i];
		m_IniSetUpInfo.SetIntValue( "PARTS LIFE TIME (GLASS COUNT)", 
			m_infoPartsLifeTimePara[i].sName, m_nValuePartsLifeTimePara[0][i], TRUE );

		m_nValuePartsLifeTimePara[1][i] = m_nValuePartsLifeTimeParaTemp[1][i];
		m_IniSetUpInfo.SetIntValue( "PARTS LIFE TIME (RUN TIME)", 
		m_infoPartsLifeTimePara[i].sName, m_nValuePartsLifeTimePara[1][i], TRUE );
	}
}

//--------------------------------------------------------------------
// SetRegistrySensorIntr()
//--------------------------------------------------------------------
void CSetupItems::SetRegistryTabInterlockSetView()
{
	for( int i=0; i<m_pEqpAssy->m_AnalogInput.GetAiSize(); i++ )
	{
		int nReal = m_pEqpAssy->m_AnalogInput.GetAddress( i );
		int nIntrNo = m_pEqpAssy->m_AnalogInput.m_aiSet[i].nAiIntrNo;
		if( nIntrNo < 0 ) continue;
		
		m_nValueGaugeLimit_Option[nIntrNo] = m_nValueGaugeLimit_OptionTemp[nIntrNo];
		for( int j=0; j<4; j++ )
		{
			m_nValueGaugeLimit[j][nIntrNo] = m_nValueGaugeLimitTemp[j][nIntrNo];
		}

		m_pDevice->SetInterlockPara( nReal, m_nValueGaugeLimit_Option[nIntrNo], 
			m_nValueGaugeLimit[3][nIntrNo], m_nValueGaugeLimit[0][nIntrNo] );
		m_pDevice->SetWarningPara( nReal, m_nValueGaugeLimit_Option[nIntrNo],
			m_nValueGaugeLimit[2][nIntrNo], m_nValueGaugeLimit[1][nIntrNo] );
	}
}
//--------------------------------------------------------------------
// SetRegistrySensorIntr()
//--------------------------------------------------------------------
void CSetupItems::SetRegistryTabInterlockSet2View()
{
	int i;
	m_IniSetUpInfo.Open("EqpInterlock2","SETUPINFO");

	for( i=0; i<m_nItemNoDoorIntr; i++ )
	{
		m_nValueDoorIntr[i] = m_nValueDoorIntrTemp[i];
		m_IniSetUpInfo.SetIntValue( "INTERLOCK SET : DOOR OPEN", m_sItemDoorIntr[i], m_nValueDoorIntr[i], TRUE );
	}
	for( i=0; i<m_nItemNoBathCoverIntr; i++ )
	{
		m_nValueBathCoverIntr[i] = m_nValueBathCoverIntrTemp[i];
		m_IniSetUpInfo.SetIntValue( "INTERLOCK SET : BATH COVER", m_sItemBathCoverIntr[i], m_nValueBathCoverIntr[i], TRUE );
	}
	for( i=0; i<m_nItemNoLeakDetectIntr; i++ )
	{
		m_nValueLeakDetectIntr[i] = m_nValueLeakDetectIntrTemp[i];
		m_IniSetUpInfo.SetIntValue( "INTERLOCK SET : LEAK", m_sItemLeakDetectIntr[i], m_nValueLeakDetectIntr[i], TRUE );
	}
	for( i=0; i<m_nItemNoFFUAlarmIntr; i++ )
	{
		m_nValueFFUAlarmIntr[i] = m_nValueFFUAlarmIntrTemp[i];
		m_IniSetUpInfo.SetIntValue( "INTERLOCK SET : FFU", m_sItemFFUAlarmIntr[i], m_nValueFFUAlarmIntr[i], TRUE );
	}
/*
	for( i=0; i<m_nItemNoBrokenIntr; i++ )
	{
		m_nValueBrokenIntr[i] = m_nValueBrokenIntrTemp[i];
		m_IniSetUpInfo.SetIntValue( "INTERLOCK SET(BROKEN)", m_sItemBrokenIntr[i], m_nValueBrokenIntr[i], TRUE );
	}
*/
	for( i=0; i<m_nItemNoETCIntr; i++ )
	{
		m_nValueETCIntr[i] = m_nValueETCIntrTemp[i];
		m_IniSetUpInfo.SetIntValue( "INTERLOCK SET : ETC", m_sItemETCIntr[i], m_nValueETCIntr[i], TRUE );
	}

}
//--------------------------------------------------------------------
// SetRegistryTab3()
//--------------------------------------------------------------------
void CSetupItems::SetRegistryTabCVDistanceSetView()
{
	m_IniSetUpInfo.Open("CvDistancePara","SETUPINFO");

	int i;
	for( i=0; i<m_nItemNoCvLength; i++ )
	{
		CString sBuf;
		m_fValueCvLength[i] = m_fValueCvLengthTemp[i];
		sBuf.Format( "%.1f", m_fValueCvLength[i] );
		m_IniSetUpInfo.SetStringValue( "CV DISTANCE", m_sItemCvLength[i], sBuf, TRUE );
	}

	for( i=0; i<m_nItemNoInSensorTimeOut; i++ )
	{
		m_nValueInSensorOffTimeOut[i] = m_nValueInSensorOffTimeOutTemp[i];
		m_IniSetUpInfo.SetIntValue( "IN SENSOR OFF TIMEOUT", m_sItemInSensorOffTimeOut[i], m_nValueInSensorOffTimeOut[i], TRUE );
	}

	for( i=0; i<m_nItemNoOutSensorTimeOut; i++ )
	{
		m_nValueOutSensorOffTimeOut[i] = m_nValueOutSensorOffTimeOutTemp[i];
		m_IniSetUpInfo.SetIntValue( "OUT SENSOR OFF TIMEOUT", m_sItemOutSensorOffTimeOut[i], m_nValueOutSensorOffTimeOut[i], TRUE );
	}
}

void CSetupItems::SetRegistryTabInterfaceParaView()
{
	int i;
	m_IniSetUpInfo.Open("Interface","SETUPINFO");

	for( i=0; i<m_nItemNoHsmsPara; i++ )
	{
		m_sValueHsmsPara[i] = m_sValueHsmsParaTemp[i];
		m_IniSetUpInfo.SetStringValue( "HSMS PARAMETER", m_infoHsmsPara[i].sName, m_sValueHsmsPara[i], TRUE );
	}

	for( i=0; i<m_nItemNoInterfacePara; i++ )
	{
		m_sValueInterfacePara[i] = m_sValueInterfaceParaTemp[i];
		m_IniSetUpInfo.SetStringValue( "IF PARAMETER", m_infoInterfacePara[i].sName, m_sValueInterfacePara[i], TRUE );
	}
}

void CSetupItems::SetRegistryTabInterfaceParaView1()
{
	m_IniSetUpInfo.Open("Interface1","SETUPINFO");

	for( int i=0; i<m_nItemNoHsmsPara1; i++ )
	{
		m_sValueHsmsPara1[i] = m_sValueHsmsParaTemp1[i];
		m_IniSetUpInfo.SetStringValue( "HSMS PARAMETER(2)", m_infoHsmsPara1[i].sName, m_sValueHsmsPara1[i], TRUE );
	}
}
//--------------------------------------------------------------------
// SetRegistryTab4()
//--------------------------------------------------------------------
void CSetupItems::SetRegistryTabCVMotorParaView()
{
/*
	for( int i=0; i<m_nItemNoCvMotorPara; i++ )
	{
		CString sBuf1;
		m_fValueCvMotorRatio[i] = m_fValueCvMotorRatioTemp[i];
		sBuf1.Format( "%.1f", m_fValueCvMotorRatio[i] );
		m_IniSetUpInfo.SetStringValue( "C/V MOTOR RATIO", m_infoCvMotorPara[i].sName, sBuf1, TRUE );

		m_fValueCvMotorDia[i] = m_fValueCvMotorDiaTemp[i];
		sBuf1.Format( "%.1f", m_fValueCvMotorDia[i] );
		m_IniSetUpInfo.SetStringValue( "C/V MOTOR DIAMETER", m_infoCvMotorPara[i].sName, sBuf1, TRUE );

		m_fValueCvMotorVelRatio[i] = m_fValueCvMotorVelRatioTemp[i];
		sBuf1.Format( "%.3f", m_fValueCvMotorVelRatio[i] );
		m_IniSetUpInfo.SetStringValue( "C/V MOTOR VELOCITY", m_infoCvMotorPara[i].sName, sBuf1, TRUE );
	}
*/
}

//--------------------------------------------------------------------
// SetRegistryTab5()
//--------------------------------------------------------------------
void CSetupItems::SetRegistryTabDVParaView()
{
	m_IniSetUpInfo.Open("DV PARA","SETUPINFO");

	for( int i=0; i<m_nItemNoDvName; i++ )
	{
		m_sValueDvName[i] = m_sValueDvNameTemp[i];
		m_IniSetUpInfo.SetStringValue( "D/V PARAMETER", m_sItemDvName[i], m_sValueDvName[i], TRUE );
	}
}

void CSetupItems::SetRegistryDualSensorSkip()
{
	for(int i=0; i<MAX_UNIT_NO; i++ )
	{
		m_IniDualSensorSkip.SetIntValue( "DICS SET TAB JOB COND", m_sItemInSensorSkip[i], m_nValueInSensorSkipTemp[i], TRUE);
		m_IniDualSensorSkip.SetIntValue( "DICS SET TAB JOB COND", m_sItemOutSensorSkip[i], m_nValueOutSensorSkipTemp[i], TRUE);
		
		m_IniDualSensorSkip.SetIntValue( "DICS SET TAB JOB COND", m_sItemSubInSensorSkip[i], m_nValueSubInSensorSkipTemp[i], TRUE);
		m_IniDualSensorSkip.SetIntValue( "DICS SET TAB JOB COND", m_sItemSubOutSensorSkip[i], m_nValueSubOutSensorSkipTemp[i], TRUE);	
	}
}
